PROGRAM_NAME='VAV_!MyWeather_AXI'
/////////////////////////////////////////////////////////////
(***********************************************************)
(*  FILE CREATED ON: 08/10/2006  AT: 12:16:49              *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 01/06/2009  AT: 15:41:20        *)
(***********************************************************)
/////////////////////////////////////////////////////////////

DEFINE_DEVICE

(*VAVAVAVAVVAVAVAVAV TCP/IP DEVICES VAVAVAVAVAVAVAVAVVAVVAV*) 
/////////////////////////////////////////////////////////////
////////  You should have one of these for each  ////////////
////// instance of the module to avoid collisions ///////////
/////////////////////////////////////////////////////////////

//dvRSS              = 0:4:0
//
///////////////////////////////////////////////////////////////
//(*VAVAVAVAVVAVAVAVAV  TOUCH PANELS  VAVAVAVAVAVAVAVAVVAVVAV*) 
// 
//#IF_NOT_DEFINED WEATHER_UIs
//dvTP_Weather_1        	= 10001:23:0 ;
//dvTP_Weather_2        	= 10002:23:0 ;
//dvTP_Weather_3       	= 10003:23:0 ;
//dvTP_Weather_4        	= 10004:23:0 ;
//dvTP_Weather_5        	= 10005:23:0 ;
//dvTP_Weather_6        	= 10006:23:0 ;
//dvTP_Weather_7        	= 10007:23:0 ;
//#END_IF
//
//#IF_NOT_DEFINED R4_Weather_UIs 
//dvR4_Weather_1        	= 10021:6:0 ; 
//dvR4_Weather_2        	= 10022:6:0 ;
//dvR4_Weather_3        	= 10023:6:0 ;
//dvR4_Weather_4        	= 10024:6:0 ;
//#END_IF

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)

DEFINE_CONSTANT // city, state & country for weather

CHAR WEATHER_CNTRY[]  = 'US' ; //2 letters for the country
CHAR WEATHER_STATE[]  = 'CT' ; //2 letters for the state
CHAR WEATHER_CITY[]   = 'Westport' ; //30 letters max (check RSSWeather.com for covered cities)  

DEFINE_CONSTANT // refresh rate (no less than 60)

(***********************************************************)
/////////////////////////////////////////////////////////////
/// MUST RE-COMPILE MODULE FOR CHANGES TO TAKE AFFECT!!!! ///
/////////////////////////////////////////////////////////////
                    /////////////////////////////////////////
REFRESH_TIME = 60 ; ///*time in minutes between RSS data *///
		    ///Refresh, CAN'T BE SET LESS THAN 60 ///
		    ///-------------(1 hour)--------------///
		    /////////////////////////////////////////
/////////////////////////////////////////////////////////////			 
DEFINE_VARIABLE

VOLATILE INTEGER nWindSpeed ;
VOLATILE INTEGER nWindGusts ;
VOLATILE INTEGER nWx_HoldSitRep ;

VOLATILE DEV dvUI_WxArry[NUM_UIs_IN_SYSTEM] =

     {
     dvTP_Weather_1,
     dvTP_Weather_2,
     dvTP_Weather_3,
     dvTP_Weather_4,
     dvTP_Weather_5,
     dvTP_Weather_6,
     dvTP_Weather_7,
     dvR4_Weather_1,
     dvR4_Weather_2,
     dvR4_Weather_3,
     dvR4_Weather_4,
     dvR4_Weather_5,
     dvR4_Weather_6,
     dvR4_Weather_7,
     dvR4_Weather_8
     } 

VOLATILE INTEGER nUI_WxActiveArry[NUM_UIs_IN_SYSTEM] ;     

non_volatile integer nWxRefreshTime = REFRESH_TIME ;

volatile integer nWx_DeBug ;

volatile integer nWxBtnArry [] =
     {	
     1,  // Manually refresh weather data
     2,  // spares
     3,  //    v
     4,  //    v
     5,  //    v
     6,  //    v
     7,  //    v
     8,  //    v
     9,  //    v
     10  // spares
     } ;
     
/////////////////////////////////////////////////////////////     
////////////////  TOUCH PANEL VT FIELDS  ////////////////////
///  Make these match your address code for text input!!  ///
///     To prevent collisions, you either need seperate   ///
///      definitions for each instance of the module,     ///
///   *OR* define different ports/panels for each city    ///
/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

VOLATILE INTEGER nWxFBChnls[] =
 
     {
     10, // VT_lastupdate   
     11, // VT_title        
     12, // VT_rcvdzip      
     13, // VT_overview     
     14, // VT_description  
     15, // VT_icon         
     16, // VT_pubdate      
     17, // VT_humidity     
     18, // VT_windspeed    
     19, // VT_winddir      
     20, // VT_gusts        
     21, // VT_pressure     
     22, // VT_dewpoint     
     23, // VT_heatindex    
     24, // VT_windchill    
     25, // VT_visibility   
     26, // VT_fcastTitle_1 
     27, // VT_forecast_1 
     28, // VT_fcastTitle_2 
     29, // VT_forecast_2   
     30, // VT_fcastTitle_3 
     31, // VT_forecast_3   
     32, // VT_fcastTitle_4 
     33, // VT_forecast_4   
     34, // VT_fcastTitle_5 
     35, // VT_forecast_5   
     36  // WeatherIcon_Btn 
     } ;

/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////
/// Create one for every city you wish to track, make a   ///
///      seperate instance of the module for each         ///
///  Change any element and the module will update with   ///
///             new weather data on-the-fly               ///
/////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////

PERSISTENT CHAR CityData[6][30] ; (*original method*)
     //{
//		    // leave unkown fields as '' (no space between)
//		    // (you should get info back with just city,state, country & zip)
//     {''},	    // Country: figure this out yourself
//     {''},	    // go to >>> http://www.itl.nist.gov/fipspubs/co-codes/states.htm 
//		    // (to find code for your area)
//     {'State'},	    // State: figure this out yourself
//     {'CTZ001'},    // go to >>> http://weather.noaa.gov/pub/data/forecasts/marine/coastal/
//		    // (coastal and inland waterways) (you could parse this page it you want!!)
//     {'Westport'}, // City: figure this out yourself
//     {'06880'}	    // Zipcode: figure this out yourself
//     
//     } ;

/////////////////////////////////////// TPs and R4 gets data updates
//VOLATILE DEV dvTP_R4WeatherArry[] =  	{
//					dvTP_Weather_1,
//					dvTP_Weather_2,
//					dvTP_Weather_3,
//					dvTP_Weather_4,
//					dvTP_Weather_5,
//					dvTP_Weather_6,
//					dvTP_Weather_7//,
//					//vdvTPR4_1_Weather,
//					//vdvTPR4_2_Weather				   
//					} ;
//				   
//////////////////////////////////////// dms pads get formatted string data updates // use a virtual if no DMS
//////////////////////////////////////// dms device numbers must be under 12000 and in none the virtual needs to be above 33000
////VOLATILE DEV dvDMSWeatherArry[] = {dvDMS_LivRm_Weather,dvDMS_Office_Weather,dvDMS_MBath_Weather,dvDMS_Guest_Weather} ;
//
//////////////////////////////////////// TPs get forecast data updates
//VOLATILE DEV dvTPWeatherG4Arry[] = {
//				   dvTP_Weather_1,
//                                   dvTP_Weather_2,
//                                   dvTP_Weather_3,
//                                   dvTP_Weather_4,
//                                   dvTP_Weather_5,
//                                   dvTP_Weather_6,
//                                   dvTP_Weather_7 
//				   } ;

(***********************************************************)
(*                MODULE DEFINITIONS GO BELOW              *)
(***********************************************************)
DEFINE_START

     {
     CityData[1] = WEATHER_CNTRY ;
     CityData[3] = WEATHER_STATE ;
     CityData[5] = WEATHER_CITY ;
     }

DEFINE_MODULE  'VAV_!MyWeatherMod1' WEATH_1 (dvRSS_Wx,vSitrep_Client,CityData,
					    dvUI_WxArry,nUI_TypeArry,nUI_WxActiveArry,nWxBtnArry,nWxFBChnls,
					    nWxRefreshTime,nWindSpeed,nWindGusts,nWx_HoldSitRep,nWx_DeBug) ;
