﻿PROGRAM_NAME='VAV_SITREP_Client'

DEFINE_DEVICE   //DEFINED IN MAIN (EMPTY)

DEFINE_CONSTANT //DEFAULT USER / PASS

CHAR SITREP_MAX_REPORTS		= 8 ;
CHAR SITREP_USER[100]		= 'user' ;     //user for your server(master) as defined in VAV_Sitrep_Server
CHAR SITREP_PASS[100]		= 'password' ; //password for your server (master) as defined in VAV_Sitrep_Server
CHAR SITREP_JOB[100]		= 'job_name' ; //typically the customer's name
CHAR SITREP_DEFAULT_URL[]	= 'yourdnsname.dyndns.org' ;

CHAR SITREP_SERVER_URL  	= 255 ;
CHAR SITREP_MAX_STRING 		= 255 ;
CHAR SITREP_MAX_LINE		= 255 ;
CHAR SITREP_CTS			= 0 ;

INTEGER STR_MAX_AMXMTU		= 1440 ;


INTEGER SITTREP_MAX_MSG_LEN    	= 2048 ;
INTEGER SITTREP_MAX_FILE_LEN    = 60000 ;

DEFINE_CONSTANT //DEFINE SERVER PORT USED ON YOUR MONITORING MASTER

INTEGER SITREP_PORT	    	= 8101 ;//as defined in VAV_Sitrep_Server

(* Base64 *)
// Limits
#IF_NOT_DEFINED ENCR_MAX_ENC_LEN
ENCR_MAX_ENC_LEN      = 1000
#END_IF
#IF_NOT_DEFINED ENCR_MAX_DEC_LEN
ENCR_MAX_DEC_LEN      = 750
#END_IF

DEFINE_TYPE     //MESSAGE QUEUE

STRUCTURE _sSitrepMsg //match the VAV_SitRep_ModClient structure
     
     {
     CHAR cTask[256] ;
     CHAR cFrom[256] ;
     CHAR cURL[256] ;
     CHAR cUser[128] ;
     CHAR cPass[128] ;
     CHAR cSubj[256] ;
     CHAR cBody[4096] ;
     CHAR cFile[256] ;
     CHAR cTime[8] ;
     CHAR cLDate[10] ;
     }

DEFINE_TYPE     //SITREP STATUS

STRUCTURE _sSitrep
     
     {
     CHAR nDeBug ;
     CHAR nConnectState ;
     CHAR nConnectAttempts ;
     CHAR nQHasItems ;
     CHAR nQTLActive ;
     CHAR nQTLReps ;
     CHAR nQHead ;
     CHAR nQTail ;
     CHAR nState ;
     LONG nPort ;
     } 
     
DEFINE_VARIABLE //STACT VARS, BUFF, DEBUG, ETC.....

VOLATILE _sSitrepMsg  sSitrepQ[SITREP_MAX_REPORTS] ;
VOLATILE _sSitrep sSitrep ;

VOLATILE CHAR cSitRep_vBuff[8192] ;

//VOLATILE CHAR cSitrep_Read_MSG[SITTREP_MAX_MSG_LEN] ;

VOLATILE CHAR nSitrep_DeBug = 0 ;
//#WARN 'SITREP.axi Debug set to 1'

VOLATILE LONG nSitrep_TL_Time[]	= {1000} ;

(* Base 64 *)
VOLATILE CHAR cEncrBase64[] = {
                               'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',   //  0 to  7
                               'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',   //  8 to 15
                               'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',   // 16 to 23
                               'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',   // 24 to 31
                               'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',   // 32 to 39
                               'o', 'p', 'q', 'r', 's', 't', 'u', 'v',   // 40 to 47
                               'w', 'x', 'y', 'z', '0', '1', '2', '3',   // 48 to 55
                               '4', '5', '6', '7', '8', '9', '+', '/'    // 56 to 63
                              } ;



(****************************)
(* NAME: EncrBase64Encode   *)

DEFINE_FUNCTION fnSitrep_DeBug(CHAR iStr[])

     {
     if(nSitrep_DeBug)
	  {
	  STACK_VAR CHAR cCopyStr[1024] ;
	  STACK_VAR INTEGER nLineCount ;
	  
	  cCopyStr = iStr ;
	  
	  nLineCount ++ ;
	  WHILE(length_string(cCopyStr) > 80)
	       {
	       SEND_STRING 0,"'SITREP.axi (',itoa(nLineCount),') DEBUG: ',get_buffer_string(cCopyStr,80)" ;
	       nLineCount ++
	       }
	  if(length_string(cCopyStr))
	       {
	       SEND_STRING 0,"'SITREP.axi (',itoa(nLineCount),') DEBUG: ',cCopyStr" ;
	       }
	  }
     
     RETURN ;
     } 
     
DEFINE_FUNCTION fnFile_OpenERR(SLONG iERR)

     {
     STACK_VAR CHAR cErrorMsg[56] ;
	  
     SELECT
	  {
	  ACTIVE(iERR  >  0): {cErrorMsg = 'file open was successful'} //won'thappen here
	  ACTIVE(iERR == -2): {cErrorMsg = 'invalid file path or name'}
	  ACTIVE(iERR == -5): {cErrorMsg = 'disk I/O error'} 
	  ACTIVE(iERR == -3): {cErrorMsg = 'invalid value supplied for IOFlag'}
	  ACTIVE(iERR == -14):{cErrorMsg = 'max numbe of files open (max 10)'}
	  ACTIVE(iERR == -15):{cErrorMsg = 'invalid file format'}
	  }
     fnSitrep_DeBug("'File Open ERR: ',cErrorMsg,'! :DEBUG<',ITOA(__LINE__),'>'") ;
     
     RETURN ;
     }
     
DEFINE_FUNCTION fnFile_SeekERR(SLONG iERR)

     {
     STACK_VAR CHAR cErrorMsg[56] ;
	  
     SELECT
	  {
	  ACTIVE(iERR  >  0): {cErrorMsg = 'pointer not set to 0'}
	  ACTIVE(iERR ==  0): {cErrorMsg = 'file empty'}
	  ACTIVE(iERR == -1): {cErrorMsg = 'invalid file handle'}
	  ACTIVE(iERR == -6): {cErrorMsg = 'invalid parameter (pointer at or beyong E.O.F.'} 
	  ACTIVE(iERR == -5): {cErrorMsg = 'disk I/O error'}
	  }
     fnSitrep_DeBug("'File Seek ERR: ',cErrorMsg,'! :DEBUG<',ITOA(__LINE__),'>'") ;
     
     RETURN ;
     }
     
DEFINE_FUNCTION fnFile_ReadERR(SLONG iERR)

     {
     STACK_VAR CHAR cErrorMsg[56] ;
	  
     SELECT
	  {
	  ACTIVE(iERR == -9): {cErrorMsg = 'end-of-file reached'}
	  ACTIVE(iERR == -6): {cErrorMsg = 'invalid parameter'}
	  ACTIVE(iERR == -5): {cErrorMsg = 'disk I/O error'} 
	  ACTIVE(iERR == -1): {cErrorMsg = 'invalid file handle'}
	  ACTIVE(iERR == -0): {cErrorMsg = 'zero bytes returned?'}
	  ACTIVE(iERR ==  0): {cErrorMsg = 'zero bytes returned?'}
	  }              
     fnSitrep_DeBug("'File Read ERR: ',cErrorMsg,'! :DEBUG<',ITOA(__LINE__),'>'") ;
     
     RETURN ;
     }
     
DEFINE_FUNCTION fnFile_CloseERR(SLONG iERR)

     {
     STACK_VAR CHAR cErrorMsg[56] ;
	  
     SELECT
	  {
	  ACTIVE(iERR == -1): {cErrorMsg = 'invalid file handle'}
	  ACTIVE(iERR == -7): {cErrorMsg = 'file already closed'}
	  ACTIVE(iERR == -5): {cErrorMsg = 'disk I/O error'} 
	  }              
     fnSitrep_DeBug("'File Close ERR: ',cErrorMsg,'! :DEBUG<',ITOA(__LINE__),'>'") ;
     
     RETURN ;
     }
     
DEFINE_FUNCTION fnSitrep_ClearToSend()

     {
     CANCEL_WAIT 'CLEAR_TO_SEND_TIMEOUT' ;
     sSitrep.nState = 0 ;
     }
    
DEFINE_FUNCTION SLONG fnSitrepQueMSG(CHAR iTask[],CHAR iFrom[],CHAR iURL[],CHAR iUser[],CHAR iPass[],CHAR iSubject[],CHAR iBody[],CHAR iFile[])
     
     {
     //fnSitrep_DeBug("'Sitrep Queue, Queing Msg Q Index-',itoa(sSitrep.nQHead),' :DEBUG<',ITOA(__LINE__),'>'") ;
     sSitrepQ[sSitrep.nQHead].cTask   	= iTask ;
     sSitrepQ[sSitrep.nQHead].cFrom   	= iFrom ;
     sSitrepQ[sSitrep.nQHead].cURL      = iURL ;
     sSitrepQ[sSitrep.nQHead].cUser  	= iUser ;
     sSitrepQ[sSitrep.nQHead].cPass     = iPass ;
     sSitrepQ[sSitrep.nQHead].cSubj  	= iSubject ;
     sSitrepQ[sSitrep.nQHead].cBody     = iBody ;
     sSitrepQ[sSitrep.nQHead].cFile	= iFile ;
     sSitrepQ[sSitrep.nQHead].cTime     = TIME ;
     sSitrepQ[sSitrep.nQHead].cLDate    = LDATE ;   //
     //fnSitrep_DeBug("'Queued Report Subj: "',sSitrepQ[sSitrep.nQHead].cSubj,'" :DEBUG <',ITOA(__LINE__),'>'") ;
     
     SELECT
	  {
	  ACTIVE(sSitrep.nQHead == SITREP_MAX_REPORTS): 
	       {// If head is at end
	       if(sSitrep.nQTail <> 1) 
		    {// Don't overwrite if full
		    sSitrep.nQHead = 1 ;
		    }
	       }
	  ACTIVE(sSitrep.nQTail <> sSitrep.nQHead + 1): 
	       {// Don't overwrite if full
	       sSitrep.nQHead++ ;
	       }
	  }
     
     sSitrep.nQHasItems = 1 ;
     
     if(!TIMELINE_ACTIVE(TL_SITREP))
	  {
	  TIMELINE_CREATE(TL_SITREP,nSitrep_TL_Time,1,TIMELINE_ABSOLUTE,TIMELINE_REPEAT) ;
	  sSitrep.nQTLActive = 1 ;
	  }
          
     RETURN sSitrep.nQHead ;
     }
  
DEFINE_FUNCTION fnSitrepSend_QMsg() 
     
     {
     fnSitrep_DeBug("'TX_Msg, Begin process :DEBUG<',ITOA(__LINE__),'>'") ;
     sSitrep.nState = 1 ;
     WAIT 300 'CLEAR_TO_SEND_TIMEOUT'
	  {
	  fnSitrep_ClearToSend() ;
	  }
     SEND_STRING dvSitRep_Client,"'!New Task!: ',STR_CRLF" ;
     SEND_STRING dvSitRep_Client,"'!Task!: ',sSitrepQ[sSitrep.nQTail].cTask,STR_CRLF" ;
     SEND_STRING dvSitRep_Client,"'!From!: ',sSitrepQ[sSitrep.nQTail].cFrom,STR_CRLF" ;
     SEND_STRING dvSitRep_Client,"'!Time!: ',sSitrepQ[sSitrep.nQTail].cTime,STR_CRLF" ;
     SEND_STRING dvSitRep_Client,"'!Date!: ',sSitrepQ[sSitrep.nQTail].cLDate,STR_CRLF" ;
     SEND_STRING dvSitRep_Client,"'!Subject!: ',sSitrepQ[sSitrep.nQTail].cSubj,STR_CRLF" ;
     SEND_STRING dvSitRep_Client,"'!Body Begins!: ',STR_CRLF" ;//seperated in case body contains additional STR_CRLF's
     SEND_STRING dvSitRep_Client,"sSitrepQ[sSitrep.nQTail].cBody,STR_CRLF" ;
     SEND_STRING dvSitRep_Client,"'!Body Ends!: ',STR_CRLF" ;
     if(length_string(sSitrepQ[sSitrep.nQTail].cFile))
	  {
	  STACK_VAR SLONG nFileLenght ;
	  STACK_VAR SLONG nHandle ;
	  STACK_VAR LONG nPos ;
	  
	  nHandle = file_open(sSitrepQ[sSitrep.nQTail].cFile,FILE_READ_ONLY) ;
	  if(nHandle)
	       {
	       fnSitrep_DeBug("'TX_Msg, File: ',sSitrepQ[sSitrep.nQTail].cFile,' opened :DEBUG<',ITOA(__LINE__),'>'") ;
	       nFileLenght = file_seek(nHandle,$FFFFFFFF) ;//-1 using 2's comp.  look for end of file
	       if(nFileLenght)
		    {
		    STACK_VAR SLONG nReadResult ;
		    STACK_VAR SLONG nZeroPointer ;
		    STACK_VAR CHAR cFile[SITTREP_MAX_FILE_LEN] ;
		    
		    SEND_STRING dvSitRep_Client,"'!Message Size!: ',itoa(nFileLenght),STR_CRLF" ;
		    fnSitrep_DeBug("'TX_Msg, file_seek\file size = ( ',itoa(nFileLenght),' ) bytes :DEBUG<',ITOA(__LINE__),'>'") ;
		    
		    nZeroPointer = file_seek(nHandle,0) ;//set pointer back to 0 for reading
		    if(nZeroPointer == 0)
			 {
			 nReadResult = file_Read(nHandle,cFile,TYPE_CAST(nFileLenght)) ;
			 if(nReadResult)
			      {
			      SEND_STRING dvSitRep_Client,"'!Attachment Begins!: ',STR_CRLF" ;
			      
			      WHILE(nFileLenght)
				   {
				   if(nFileLenght > STR_MAX_AMXMTU)
					{
					nFileLenght = nFileLenght - STR_MAX_AMXMTU ;
					fnSitrep_DeBug("'TX_Msg, Tx (',itoa(STR_MAX_AMXMTU),') bytes, remaining ( ',itoa(nFileLenght),' ) bytes :DEBUG<',ITOA(__LINE__),'>'") ;
					SEND_STRING dvSitRep_Client,GET_BUFFER_STRING(cFile,STR_MAX_AMXMTU) ;		
					}
				   else
					{
					fnSitrep_DeBug("'TX_Msg, Tx (',itoa(nFileLenght),') bytes, remaining ( 0 ) bytes :DEBUG<',ITOA(__LINE__),'>'") ;
					SEND_STRING dvSitRep_Client,GET_BUFFER_STRING(cFile,TYPE_CAST(nFileLenght)) ;
					nFileLenght = 0 ;
					}
				   }
			      SEND_STRING dvSitRep_Client,"'!Attachment Ends!: ',STR_CRLF" ;
			      }
			 else
			      {
			      fnFile_ReadERR(nReadResult) ;
			      }
			 }
		    else
			 {
			 fnFile_SeekERR(nZeroPointer) ;
			 }
		    }
	       else
		    {
		    SEND_STRING dvSitRep_Client,"'!Message Size!: 0',STR_CRLF" ;
		    fnFile_SeekERR(nFileLenght) ;
		    }
		    
	       nHandle = file_close(nHandle) ;
	       if(nHandle == 0)
		    {
		    fnSitrep_DeBug("'TX_Msg, File: ',sSitrepQ[sSitrep.nQTail].cFile,' closed :DEBUG<',ITOA(__LINE__),'>'") ;
		    }
	       else
		    {
		    fnFile_CloseERR(nHandle) ;
		    }
	       }
	  else
	       {
	       fnFile_OpenERR(nHandle) ;
	       }
	  }
     else
	  {
	  SEND_STRING dvSitRep_Client,"'!Message Size!: 0',STR_CRLF" ;
	  SEND_STRING dvSitRep_Client,"'No file specified to send.',STR_CRLF" ;
	  }
     SEND_STRING dvSitRep_Client,"'!Message Complete!:',STR_CRLF" ;
     fnSitrep_DeBug("'TX_Msg, Sent ending tag! :DEBUG<',ITOA(__LINE__),'>'") ;
     	  
     SELECT 
	  {
	  ACTIVE(sSitrep.nQTail == SITREP_MAX_REPORTS):	// Rollover
	       sSitrep.nQTail = 1 ;
	  ACTIVE(1):
	       sSitrep.nQTail++ ;			// Increment
	  }
	  
     if(sSitrep.nQTail == sSitrep.nQHead)
	  sSitrep.nQHasItems = 0 ;
     
     RETURN ;
     }
     
DEFINE_FUNCTION fnEPCII_ENCRYPT_LOGIN(CHAR iChallenge[])

     {
     //sEPCII.cMD5_STRING = "iChallenge,sEPCII.cUser,sEPCII.cPass,iChallenge" ;
     //SEND_COMMAND vdvMD5_ENCRYPT,"'CYPHER-',sEPCII.cMD5_STRING" ;
     //fnEPCII_DeBug("'ECRYPT LOGIN (MD5_STRING)= ',sEPCII.cMD5_STRING,' :DEBUG <',ITOA(__LINE__),'>'") ;
     
     RETURN ;
     }
    
DEFINE_FUNCTION fnSitrep_IPOpen()  
     
     {
     LOCAL_VAR SLONG nSitrepStatus ;
     
     if(sSitrep.nConnectState == IP_CLIENT_DISCO) 
	  {
	  //fnSitrep_DeBug("'Attempting IP_Open: Knock, Knock. :DEBUG<',ITOA(__LINE__),'>'") ;
	  //fnSitrep_DeBug("'Attempting IP_Open for host: ',sSitrepQ[sSitrep.nQTail].cURL,'. Called from :DEBUG<',ITOA(__LINE__),'>'") ;
	  sSitrep.nConnectAttempts++ ;
	  sSitrep.nConnectState = IP_CLIENT_PENDING ;
	  
	  WAIT 300 'CLEAR_CONNECT_PENDING'
	       {
	       sSitrep.nConnectState = IP_CLIENT_DISCO ;
	       }
	       
	  IP_CLIENT_OPEN(dvSitRep_Client.Port,sSitrepQ[sSitrep.nQTail].cURL,sSitrep.nPort,1) ;
	  }
	  
     RETURN ;
     }
     
DEFINE_FUNCTION fnSitrep_IPClose()   
     
     {
     //CANCEL_WAIT 'LONG_WAITING_TO_CONNECT' ;
     CANCEL_WAIT 'CLEAR_CONNECT_PENDING' ;
 
     sSitrep.nConnectState = IP_CLIENT_DISCO ;
     IP_CLIENT_CLOSE(dvSitRep_Client.Port) ;
 
     RETURN ;
     }
     
DEFINE_FUNCTION fnSitrep_Online()   

     {
     //fnSitrep_DeBug("'ONLINE :DEBUG <',ITOA(__LINE__),'>'") ;
     
     //CANCEL_WAIT 'LONG_WAITING_TO_CONNECT' ;
     CANCEL_WAIT 'CLEAR_CONNECT_PENDING' ;
     sSitrep.nConnectState = IP_CLIENT_CONNECTED ;
     sSitrep.nConnectAttempts = 0 ;
     sSitrep.nQTLReps = 0 ;
 	
     RETURN ;
     }
     
DEFINE_FUNCTION fnSitrep_Offline()  
    
     {
     //prevent closing after rx goodbye from server since server closes the connection first then local closing causes an err. 
     CANCEL_WAIT 'FOR_SSERVER_GOODBYE' ;
     CANCEL_WAIT 'CLEAR_CONNECT_PENDING' ;
     sSitrep.nConnectState = IP_CLIENT_DISCO ;
     //fnFB_DoSend_CHNL(UI_UPDATE_ACTIVE,254,CH_OFF) ;
     
     if(sSitrep.nQHasItems)
	  {
    	  fnSitrep_IPOpen() ;
	  }
     
     RETURN ;
     }
     
DEFINE_FUNCTION fnSitrep_OnError(LONG iError) 
     
     {
     STACK_VAR CHAR cErrMsg[64] ;
     
     SELECT
	  {
	  ACTIVE(iError ==  0):{cErrMsg = 'operation was successful'}
	  //ACTIVE(iError == -1):{cErrMsg = 'invalid server port'}               //servers
	  //ACTIVE(iError == -2):{cErrMsg = 'invalid value for Protocol'}        //servers
	  //ACTIVE(iError == -3):{cErrMsg = 'unable to open communication port'} //servers 
	  ACTIVE(iError ==  2):{cErrMsg = 'General failure (out of memory)'} 
	  ACTIVE(iError ==  4):
	       {
	       cErrMsg = 'Unknown host' ;
	       fnSitrep_DeBug("cErrMsg,', Make sure the DNS entries are entered for this master :DEBUG<',ITOA(__LINE__),'>'") ;
	       RETURN ;
	       } 
	  ACTIVE(iError ==  6):
	       {
	       cErrMsg = 'Connection refused' ;
	       fnSitrep_DeBug("cErrMsg,', Check Sitrep server (? not listening at port ',ITOA(sSitrep.nPort),') :DEBUG<',ITOA(__LINE__),'>'") ;
	       RETURN ;
	       } 
	  ACTIVE(iError ==  7):
	       {
	       cErrMsg = 'Connection timed out' ;
	       fnSitrep_DeBug("cErrMsg,' The server appears to be offline :DEBUG<',ITOA(__LINE__),'>'") ;
	       RETURN ;
	       }
	  ACTIVE(iError ==  8):{cErrMsg = 'Unknown connection error'} 
	  ACTIVE(iError ==  9):{cErrMsg = 'Already closed'} 
	  ACTIVE(iError == 10):{cErrMsg = 'Binding error'} 
	  ACTIVE(iError == 14):
	       {
	       cErrMsg = 'Local port already used' ;
	       fnSitrep_IPClose() ;
	       fnSitrep_ClearToSend() ;
	       RETURN ;
	       }
	  ACTIVE(iError == 15):{cErrMsg = 'UDP socket already listening'} 
	  ACTIVE(iError == 16):{cErrMsg = 'Too many open sockets'} 
	  ACTIVE(iError == 17):{cErrMsg = 'Local Port Not Open'} 
	  ACTIVE(1):           {cErrMsg = "'OnError NO MATCH. ERR# ',itoa(iError)"}
	  }
     fnSitrep_DeBug("cErrMsg,' :DEBUG<',ITOA(__LINE__),'>'") ;
     
     RETURN ;
     }
     
DEFINE_START    //START UP CODE

sSitrep.nQTail 		= 1 ;
sSitrep.nQHead 		= 1 ;
sSitrep.nQHasItems 	= 0 ;
sSitrep.nPort 		= SITREP_PORT ; 

sSitrep.nConnectState = IP_CLIENT_DISABLED ;
WAIT 600
     {
     sSitrep.nConnectState = IP_CLIENT_DISCO ;
     }
     
CREATE_BUFFER vSitrep_Client,cSitRep_vBuff ;

//DEFINE_MODULE  'Cypher Module' SITREP(vdvMD5_ENCRYPT)

DEFINE_EVENT    //DATA_EVENT[dvSitRep_Client]

DATA_EVENT[dvSitRep_Client]		
     
     {
     ONLINE: 
	  {
	  fnSitrep_Online() ;
	  }
     OFFLINE: 
	  {
	  fnSitrep_Offline() ;
	  }
     ONERROR:
	  {
	  fnSitrep_OnError(DATA.NUMBER) ;
	  }
     STRING: 
	  {
	  //fnSitrep_DeBug("'RX: ',DATA.TEXT,' :DEBUG<',ITOA(__LINE__),'>'") ;
	  SELECT
	       {
	       ACTIVE(find_string(DATA.TEXT,"'user: '",1)):
		    {
		    //fnSitrep_DeBug("'Sending: ',sSitrepQ[sSitrep.nQTail].cUser,' :DEBUG<',ITOA(__LINE__),'>'") ;
		    if(length_string(sSitrepQ[sSitrep.nQTail].cUser))
			 {
			 SEND_STRING dvSitRep_Client,"sSitrepQ[sSitrep.nQTail].cUser,STR_CRLF" ;
			 }
		    else
			 {
			 SEND_STRING dvSitRep_Client,"SITREP_USER,STR_CRLF" ;
			 }
		    }
	       ACTIVE(find_string(DATA.TEXT,"'password: '",1)):
		    {
		    //fnSitrep_DeBug("'Sending: ',sSitrepQ[sSitrep.nQTail].cPass,' :DEBUG<',ITOA(__LINE__),'>'") ;
		    if(length_string(sSitrepQ[sSitrep.nQTail].cPass))
			 {
			 SEND_STRING dvSitRep_Client,"sSitrepQ[sSitrep.nQTail].cPass,STR_CRLF" ;
			 }
		    else
			 {
			 SEND_STRING dvSitRep_Client,"SITREP_PASS,STR_CRLF" ;
			 }
		    }
	       ACTIVE(find_string(DATA.TEXT,"'welcome!'",1)):
		    {
		    //fnSitrep_DeBug("'Sending: Message :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSitrepSend_QMsg() ;
		    WAIT 150 'FOR_SSERVER_GOODBYE' 
			 {
			 fnSitrep_ClearToSend() ;
			 fnSitrep_IPClose() ;
			 }
		    }
	       ACTIVE(find_string(DATA.TEXT,"'Goodbye!'",1)):
		    {
		    fnSitrep_DeBug("'MSG Transmission complete. Server said "Goodbye!" :DEBUG<',ITOA(__LINE__),'>'") ;
		    CANCEL_WAIT 'FOR_SSERVER_GOODBYE' ;
		    WAIT 150 'FOR_SSERVER_GOODBYE' 
			 {
			 fnSitrep_ClearToSend() ;
			 fnSitrep_IPClose() ;
			 }
		    }
	       ACTIVE(1):
		    {
		    //fnSitrep_DeBug("'RX Unwanted Reply: ',DATA.TEXT,' :DEBUG<',ITOA(__LINE__),'>'") ;
		    }
	       }
	  }
     }
     
DEFINE_EVENT    //DATA_EVENT[vSitrep_Client]

DATA_EVENT[vSitrep_Client]		
     
     {
     ONLINE: 
	  {
	  fnSitrep_DeBug("'vSitrep_Client Online! :DEBUG<',ITOA(__LINE__),'>'") ;
	  }
     OFFLINE: 
	  {
	  fnSitrep_DeBug("'vSitrep_Client Offline! :DEBUG<',ITOA(__LINE__),'>'") ;
	  }
     ONERROR:
	  {
	  fnSitrep_DeBug("'vSitrep_Client OnError! ERR# (',itoa(DATA.NUMBER),') :DEBUG<',ITOA(__LINE__),'>'") ;
	  }
     STRING: 
	  {
	  if(cSitRep_vBuff[1] == 1)
	       {
	       STACK_VAR _sSitrepMsg sSitrepModMsg ;
	       STACK_VAR SINTEGER nResult ;
	       STACK_VAR INTEGER nLenBuf ;
	       STACK_VAR LONG nPos ;
	       
	       GET_BUFFER_CHAR(cSitRep_vBuff) ;
	       nLenBuf = length_string(cSitRep_vBuff) ;
	     
	       nPos = 1 ;
	       nResult = STRING_TO_VARIABLE(sSitrepModMsg,cSitRep_vBuff,nPos) ;
	       if(nResult == 0)
		    {
		    fnSitrep_DeBug("'RX rcv''d (',itoa(nLenBuf),') encoded bytes, decode successfull :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSitrep_DeBug("'RX Task (',sSitrepModMsg.cTask,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSitrep_DeBug("'RX Task (',sSitrepModMsg.cFrom,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSitrep_DeBug("'RX Task (',sSitrepModMsg.cURL, ') :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSitrep_DeBug("'RX Task (',sSitrepModMsg.cUser,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSitrep_DeBug("'RX Task (',sSitrepModMsg.cPass,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSitrep_DeBug("'RX Task (',sSitrepModMsg.cSubj,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSitrep_DeBug("'RX Task (',sSitrepModMsg.cBody,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSitrep_DeBug("'RX Task (',sSitrepModMsg.cFile,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    
		    
		    fnSitrepQueMSG((*task*)sSitrepModMsg.cTask,
				   (*from*)sSitrepModMsg.cFrom,
				   (*url *)sSitrepModMsg.cURL, 
				   (*user*)sSitrepModMsg.cUser,
				   (*pass*)sSitrepModMsg.cPass,
				   (*subj*)sSitrepModMsg.cSubj,
				   (*body*)sSitrepModMsg.cBody, 
			    (*attach file*)sSitrepModMsg.cFile) ;
			    
				   //sSitrepModMsg.cTime   //set in qeue msg to current time
				   //sSitrepModMsg.cLDate  //set in qeue msg to current date
		    }
	       else
		    {
		    fnSitrep_DeBug("'RX rcv''d (',itoa(nLenBuf),') encoded bytes, decode failed (',itoa(nResult),') :DEBUG<',ITOA(__LINE__),'>'") ;
		    }
	       }
	  else
	       {
	       STACK_VAR INTEGER nLenBuf ;
	       nLenBuf = length_string(cSitRep_vBuff) ;
	       
	       fnSitrep_DeBug("'RX rcv''d (',itoa(nLenBuf),') bytes: ',cSitRep_vBuff,' :DEBUG<',ITOA(__LINE__),'>'") ;
	       }
	  
	  cSitRep_vBuff = '' ;
	  }
     }
//	  
//	  
//	  
//	  
//	  
//	  
//	  
//	  fnSitrep_DeBug("'vSitrep_Client RX: ',DATA.TEXT,' :DEBUG<',ITOA(__LINE__),'>'") ;
//	  
//	  
//	  SELECT
//	       {
//	       ACTIVE(find_string(DATA.TEXT,"'user: '",1)):
//		    {
//		    //fnSitrep_DeBug("'Sending: ',sSitrepQ[sSitrep.nQTail].cUser,' :DEBUG<',ITOA(__LINE__),'>'") ;
//		    SEND_STRING dvSitRep_Client,"sSitrepQ[sSitrep.nQTail].cUser,STR_CRLF" ;
//		    }
//	       ACTIVE(find_string(DATA.TEXT,"'password: '",1)):
//		    {
//		    //fnSitrep_DeBug("'Sending: ',sSitrepQ[sSitrep.nQTail].cPass,' :DEBUG<',ITOA(__LINE__),'>'") ;
//		    SEND_STRING dvSitRep_Client,"sSitrepQ[sSitrep.nQTail].cPass,STR_CRLF" ;
//		    }
//	       ACTIVE(find_string(DATA.TEXT,"'welcome!'",1)):
//		    {
//		    //fnSitrep_DeBug("'Sending: Message :DEBUG<',ITOA(__LINE__),'>'") ;
//		    fnSitrepSend_QMsg() ;
//		    }
//	       ACTIVE(find_string(DATA.TEXT,"'Goodbye!'",1)):
//		    {
//		    fnSitrep_DeBug("'MSG Transmission complete. Server says "Goodbye!" :DEBUG<',ITOA(__LINE__),'>'") ;
//		    fnSitrep_ClearToSend() ;
//		    fnSitrep_IPClose() ;
//		    }
//	       ACTIVE(1):
//		    {
//		    //fnSitrep_DeBug("'RX Unwanted Reply: ',DATA.TEXT,' :DEBUG<',ITOA(__LINE__),'>'") ;
//		    }
//	       }
//	  }
//     }
(*     
DEFINE_EVENT    //DATA_EVENT[vdvEPCII_MD5_ENCRYPT]        use or loose, guts commented out

DATA_EVENT[vdvMD5_ENCRYPT]
     
     {
     COMMAND:
	  {
	  //SELECT  
//	       {
//	       ACTIVE (FIND_STRING(DATA.TEXT,'CYPHER-',1)):
//		    {
//		    REMOVE_STRING(DATA.TEXT,'CYPHER-',1) ;
//		    sEPCII.cMD5_ENCRYPT_STR = "'Username=',sEPCII.cUser,'&Password=',DATA.TEXT" ;
//		    //fnEPCII_DeBug("'RX ENCRYPTED STR = ',sEPCII.cMD5_ENCRYPT_STR,' :DEBUG <',ITOA(__LINE__),'>'") ;
//		    }      
//	       ACTIVE (FIND_STRING(DATA.TEXT,'CYPHER TEST-',1)):
//		    {        
//		    //fnEPCII_DeBug("'ENCRYPTION TEST: ',DATA.TEXT,' :DEBUG <',ITOA(__LINE__),'>'") ;
//		    }      
//	       }
	  }
     }
*)     
DEFINE_EVENT    //TIMELINE_EVENT[TL_1]

TIMELINE_EVENT[TL_SITREP]  //1000ms repeating
     
     {
     sSitrep.nDeBug = nSitrep_DeBug ;//IT OLNY UPDATES IF TIMELINE IS RUNNING WHEN NOT PRESET IN CODE
       
     if(sSitrep.nQHasItems && sSitrep.nConnectState == IP_CLIENT_DISCO && sSitrep.nState == SITREP_CTS)// && sPing.nWAN_OK)
	  {
	  sSitrep.nQTLReps++ ;//used instead of timeline.reption
	  SELECT
	       {
	       ACTIVE(sSitrep.nConnectAttempts == 0)://just send
		    {
		    fnSitrep_DeBug("'Connect attempt:(',itoa(sSitrep.nConnectAttempts),'), Sitrep Server: ',sSitrepQ[sSitrep.nQTail].cURL,', no delay :DEBUG <',ITOA(__LINE__),'>'") ;
		    fnSitrep_IPOpen() ;
		    }
	       (*
	       ACTIVE(sSitrep.nConnectAttempts <= 5)://every 10 seconds
		    {
		    if(sSitrep.nQTLReps % 30 == 0)
			 {
			 fnSitrep_DeBug("'Connect attempt:(',itoa(sSitrep.nConnectAttempts),'), Sitrep Server: ',sSitrepQ[sSitrep.nQTail].cURL,', @ 10s delay :DEBUG <',ITOA(__LINE__),'>'") ;
			 fnSitrep_IPOpen() ;
			 }
		    }
	       ACTIVE(sSitrep.nConnectAttempts <= 10)://every 30 seconds
		    {
		    if(sSitrep.nQTLReps % 30 == 0)
			 {
			 fnSitrep_DeBug("'Connect attempt:(',itoa(sSitrep.nConnectAttempts),'), Sitrep Server: ',sSitrepQ[sSitrep.nQTail].cURL,', @ 30s delay :DEBUG <',ITOA(__LINE__),'>'") ;
			 fnSitrep_IPOpen() ;
			 }
		    }
	       *)
	       ACTIVE(sSitrep.nConnectAttempts <= 5)://every 5 minutes
		    {
		    if(sSitrep.nQTLReps % 300 == 0)
			 {
			 fnSitrep_DeBug("'Connect attempt:(',itoa(sSitrep.nConnectAttempts),'), Sitrep Server: ',sSitrepQ[sSitrep.nQTail].cURL,', @ 5m delay :DEBUG <',ITOA(__LINE__),'>'") ;
			 fnSitrep_IPOpen() ;
			 }
		    }
	       
	       ACTIVE(1)://once an hours 
		    {
		    if(sSitrep.nQTLReps % 3600 == 0)
			 {
			 fnSitrep_DeBug("'Connect attempt:(',itoa(sSitrep.nConnectAttempts),'), Sitrep Server: ',sSitrepQ[sSitrep.nQTail].cURL,', @ 1h delay :DEBUG <',ITOA(__LINE__),'>'") ;
			 fnSitrep_IPOpen() ;
			 }
		    }
	       }
	  }
     else if(!sSitrep.nQHasItems)
	  {
	  if(TIMELINE_ACTIVE(TL_SITREP))
	       {
	       fnSitrep_DeBug("'TIMELINE_EVENT - Q Empty, Killing Timeline :DEBUG <',ITOA(__LINE__),'>'") ;
	       TIMELINE_KILL(TL_SITREP) ;
	       sSitrep.nQTLActive = 0 ;//just for debugging info
	       }
	  }
     if(sSitrep.nQTLReps == 3600)//reset keep count reasonable
	  {
	  sSitrep.nQTLReps = 0 ;
	  }
     }
     
     
     
     
     
     
     
/////////////////////////////////////////////////////////////////////////////////////////////