﻿MODULE_NAME='VAV_SITREP_ServMod'(DEV vServer,DEV dvServer,CHAR cLogin[][],INTEGER nStats[]) 

DEFINE_CONSTANT

CHAR SERVER_DISABLED		= 0 ;
CHAR SERVER_STOPPED		= 1 ;
CHAR SERVER_PENDING		= 2 ;
CHAR SERVER_LISTENING		= 3 ;
CHAR SERVER_CONNECTED		= 4 ;
CHAR SERVER_RX_DATA		= 5 ;
CHAR SERVER_TX_DATA		= 6 ;
     
CHAR STR_CRLF[]			= {$0D,$0A} ;
CHAR PARSE_DELIM[]		= '!: ' ;
//CHAR STR_LF			= $0A ;
//CHAR STR_CR			= $0D ;
INTEGER STR_MAX_AMXMTU		= 1440 ;
INTEGER STR_MAX_CMDSTR		= 256 ;
//INTEGER STR_MAX_VIRT_STR 	= 2008 ; //31212 ; //max string that can be sent to a virtual


CHAR LOGIN_INIT			= 1 ;
CHAR LOGIN_USER_OK		= 2 ;
CHAR LOGIN_PWORD_OK		= 3 ;
CHAR LOGGED_IN          	= LOGIN_PWORD_OK ;

SSERVER_MAX_BUFF_SIZE      	= 60000 ; 

SSERVER_PATH			= 1 ;
SSERVER_FILE			= 2 ;

CHAR SSERV_TX_ENCODED		= 1 ;
CHAR SSERV_TX_NO_ENCODE		= 0 ;

//CHAR SSERV_FILE_PATH[]		= 'SITREP\SERVER_' ; //appended by instance number

DEFINE_CONSTANT //STAT ARRAY ELEMENT POINTERS 

CHAR SSERV_STAT_IP_PORT		= 1 ;
CHAR SSERV_STAT_INSTANCE	= 2 ;
CHAR SSERV_STAT_STATE		= 3 ;
CHAR SSERV_STAT_ENCODE		= 4 ;
CHAR SSERV_STAT_AUTOSTART	= 5 ;
CHAR SSERV_STAT_TYPE    	= 6 ;
CHAR SSERV_STAT_DEBUG 		= 7 ;

CHAR SSSERV_TYPE_SITREP		= 1 ;
CHAR SSSERV_TYPE_PASSBACK	= 2 ;

DEFINE_TYPE //_sSServerRX
     
STRUCTURE _sSitrep
     
     {
     //CHAR nOPCode ;
     CHAR cTask[256] ;
     CHAR cFrom[256] ;
     CHAR cTIME[8] ;
     CHAR cDATE[10] ;
     CHAR cSubject[256] ;
     CHAR cMsgSize[8] ;
     CHAR cFilePath[256] ;
     CHAR cBodyText[4096] ;
     } ;     

DEFINE_VARIABLE //

VOLATILE INTEGER nLogIn_Step = 0 ;
VOLATILE INTEGER nRequireLogin = 0 ;
VOLATILE INTEGER nServerConAttempt = 0 ;

VOLATILE CHAR cSSourceIP[15] ;
VOLATILE CHAR cSServerFile[2][128] ;
//VOLATILE CHAR cSServerFilePath[255] ;
VOLATILE CHAR cSServerMod_Buf[SSERVER_MAX_BUFF_SIZE] ;
VOLATILE LONG nAttachStart ;
VOLATILE LONG nAttachStop ;

DEFINE_FUNCTION CHAR fnSServFile_Create_Dir()  //this one is used

     {
     STACK_VAR SLONG nResult ;
	  
     nResult = FILE_CREATEDIR("'\',cSServerFile[SSERVER_PATH],'\'") ;
     if(nResult == 0)
	  {
	  fnServer_DeBug("'FILE_CREATEDIR. Success for "\',cSServerFile[SSERVER_PATH],'\" (result= ',itoa(nResult),') :DEBUG<',ITOA(__LINE__),'>'") ;
	  RETURN 1 ;
	  }
     else
	  {
	  STACK_VAR CHAR cErrorMsg[56] ;
	  
	  SELECT
	       {
	       ACTIVE(nResult == -4 ):{cErrorMsg = 'invalid directory path'}
	       ACTIVE(nResult == -5 ):{cErrorMsg = 'disk I/O error'}
	       ACTIVE(nResult == -13):{cErrorMsg = 'directory name exists'}
	       }
	  fnServer_DeBug("'FILE_CREATEDIR. Err file "\',cSServerFile[SSERVER_PATH],'\", ERR=',cErrorMsg,', (result= ',itoa(nResult),') :DEBUG<',ITOA(__LINE__),'>'") ;
	  RETURN 0 ;
	  }
     }
     
DEFINE_FUNCTION fnSServFile_File_Dir()  //not used here for reference of move to global functions.

     {
     STACK_VAR SLONG nResult ;
     STACK_VAR LONG nDirEntry ;
     STACK_VAR CHAR cDirFiles[2048] ;
     
     nDirEntry = 1 ; 
     nResult = FILE_DIR("cSServerFile[SSERVER_PATH], '\'",cDirFiles,nDirEntry) ;
     if(nResult >= 0)
	  {
	  fnServer_DeBug("'FILE_DIR. Directory "',cSServerFile[SSERVER_PATH],'" exists, result (',itoa(nResult),') :DEBUG<',ITOA(__LINE__),'>'") ;
	  }
     else
	  {
	  STACK_VAR CHAR cErrorMsg[56] ;
	  
	  SELECT
	       {
	       ACTIVE(nResult == -4 || nResult == -12):
		    {
		    SELECT
			 {
			 ACTIVE(nResult == -4 ):{cErrorMsg = 'invalid directory path'}
			 ACTIVE(nResult == -12):{cErrorMsg = 'directory not loaded'}
			 }
		    cErrorMsg = "cErrorMsg,' attempting to create'" ;
		    fnServer_DeBug("'FILE_DIR ERR. Directory "',cErrorMsg,'" :DEBUG<',ITOA(__LINE__),'>'") ;
		    
		    nResult = FILE_CREATEDIR("'\',cSServerFile[SSERVER_PATH],'\'") ;
		    if(nResult == 0)
			 {
			 fnServer_DeBug("'FILE_CREATEDIR. Success for "\',cSServerFile[SSERVER_PATH],'\" :DEBUG<',ITOA(__LINE__),'>'") ;
			 nResult = 1 ;
			 }
		    else
			 {
			 SELECT
			      {
			      ACTIVE(nResult == -4 ):{cErrorMsg = 'invalid directory path'}
			      ACTIVE(nResult == -5 ):{cErrorMsg = 'disk I/O error'}
			      ACTIVE(nResult == -13):{cErrorMsg = 'directory name exists'}
			      }
			 nResult = 0 ;
			 fnServer_DeBug("'FILE_CREATEDIR. Err file "\',cSServerFile[SSERVER_PATH],'\", ERR=',cErrorMsg,' :DEBUG<',ITOA(__LINE__),'>'") ;
			 }
	       	    }
	       ACTIVE(nResult == -5) :{cErrorMsg = 'invalid directory path'}
	       ACTIVE(nResult == -6) :{cErrorMsg = 'invalid parameter'}
	       ACTIVE(nResult == -10):{cErrorMsg = 'buffer too small'}
	       }
	  fnServer_DeBug("'FILE_DIR. Err file "\',cSServerFile[SSERVER_PATH],'\", ERR=',cErrorMsg,' :DEBUG<',ITOA(__LINE__),'>'") ;
	  }
	  
     RETURN 
     }
     
DEFINE_FUNCTION fnServer_DeBug(CHAR iStr[])

     {
     if(nStats[SSERV_STAT_DEBUG])
	  {
	  STACK_VAR CHAR cCopyStr[1024] ;
	  STACK_VAR INTEGER nLineCount ;
	  
	  cCopyStr = iStr ;
	  
	  nLineCount ++ ;
	  WHILE(length_string(cCopyStr) > 100)
	       {
	       SEND_STRING 0,"'SERVER-mod ',itoa(nStats[SSERV_STAT_INSTANCE]),',(',itoa(nLineCount),') DEBUG: ',get_buffer_string(cCopyStr,80)" ;
	       nLineCount ++
	       }
	  if(length_string(cCopyStr))
	       {
	       SEND_STRING 0,"'SERVER-mod ',itoa(nStats[SSERV_STAT_INSTANCE]),',(',itoa(nLineCount),') DEBUG: ',cCopyStr" ;
	       }
	  }
     
     RETURN ;
     } 
     
DEFINE_FUNCTION CHAR[SSERVER_MAX_BUFF_SIZE]fnConcatString(CHAR sConcatFinal[],CHAR sConcatNew[])
     //modified from original
     {
  		   // if(1)   in the code somewhere
//			 {
//			 LOCAL_VAR INTEGER nCombStrLen ;
//			 
//			 nCombStrLen = length_string(cSServMsg) + length_string(DATA.TEXT) ;
//			 
//			 if(nCombStrLen < 16000)
//			      {
//			      cSServMsg = "cSServMsg,DATA.TEXT" ;
//			      }
//			 else
//			      {
//			      cSServMsg = fnConcatString(cSServMsg,DATA.TEXT) ;
//			      }
//			 }   
     
     
     STACK_VAR CHAR sPieces[3];
     STACK_VAR CHAR sBuffer[SSERVER_MAX_BUFF_SIZE];
     STACK_VAR LONG lPos ;
     STACK_VAR LONG lOldPos ;
 
     lpos = 1;
 
     VARIABLE_TO_STRING(sConcatFinal,sBuffer,lPos);
     sPieces[1] = sBuffer[lPos-3];
     sPieces[2] = sBuffer[lPos-2];
     sPieces[3] = sBuffer[lPos-1];
 
     lOldPos = lpos;
     lpos = lpos - 3;
 
     VARIABLE_TO_STRING(sConcatNew,sBuffer,lPos);
 
     sBuffer[lOldPos-3] = sPieces[1];
     sBuffer[lOldPos-2] = sPieces[2];
     sBuffer[lOldPos-1] = sPieces[3];

     GET_BUFFER_STRING(sBuffer,3)
 
     RETURN sBuffer ;
     }
     
DEFINE_FUNCTION fnOpenServer() 

     {
     STACK_VAR SLONG nResult ; 
     
     nLogIn_Step = 0 ;
     nServerConAttempt++ ;
     //if(nStats[SSERV_STAT_STATE] == SERVER_STOPPED)
//	  {
	  
	  //STACK_VAR SLONG nResult ; 
	  nStats[SSERV_STAT_STATE] = SERVER_PENDING ;
	  fnServer_DeBug("'OPENING SERVER :DEBUG<',ITOA(__LINE__),'>'") ;
	  nResult = IP_SERVER_OPEN(dvServer.Port,nStats[SSERV_STAT_IP_PORT],1) ;
	       {
	       if(nResult)
		    {
		    fnServer_DeBug("'OPEN SERVER ERROR: ',fnGET_IPServer_Error(nResult),' :DEBUG<',ITOA(__LINE__),'>'") ;
		    }
	       else //Server ready and listening but no online event until a client connects!
		    {
		    CANCEL_WAIT 'SERVER_OPEN_TIMEOUT' ;
		    CANCEL_WAIT 'SERVER_ERR_DELAY_RESTART' ;
		   // CANCEL_WAIT 'SERVER_CLOSE_DELAY_RESTART' ; 
		    fnServer_DeBug("'SitrepServer Open successful, listening on port (',itoa(nStats[SSERV_STAT_IP_PORT]),') :DEBUG<',ITOA(__LINE__),'>'") ;
		    nStats[SSERV_STAT_STATE] = SERVER_LISTENING ; //does not generate an online event until a client connects ?
		    }
	       }
//	  }
     
     RETURN ;
     }
     
DEFINE_FUNCTION fnCloseServer() 

     {
     STACK_VAR SLONG nResult ;
     
     CANCEL_WAIT 'IDLE_TIMEOUT' ;
    // if(nStats[SSERV_STAT_STATE] > SERVER_STOPPED)
//	  {
	  //STACK_VAR SLONG nResult ;
	  
	  fnServer_DeBug("'CLOSING SERVER :DEBUG<',ITOA(__LINE__),'>'") ;
	  IP_SERVER_CLOSE(dvServer.Port) ;
	  if(!nResult)//0 if ok
	       {
	       fnServer_DeBug("'CLOSE SERVER SUCCESSFUL! :DEBUG<',ITOA(__LINE__),'>'") ;
	       nStats[SSERV_STAT_STATE] = SERVER_STOPPED ;
	       }
	  else//doesn't return here if error but wtf!
	       {
	       fnServer_DeBug("'CLOSE SERVER ERROR: ',fnGET_IPServer_Error(nResult),' :DEBUG<',ITOA(__LINE__),'>'") ;
	       }
	  if(nStats[SSERV_STAT_AUTOSTART])
	       {
	       fnOpenServer() ;
	       }
//	  }
       
     RETURN ;
     }
     
DEFINE_FUNCTION fnSServerRetry(INTEGER iTenthOfSeconds)

     {
     nStats[SSERV_STAT_STATE] = SERVER_DISABLED ;
     SWITCH(iTenthOfSeconds)
	  {
	  CASE  10:
	       {
	       WAIT 10 'SERVER_ERR_DELAY_RESTART' 
		    {
		    nStats[SSERV_STAT_STATE] = SERVER_STOPPED ;
		    }
	       }
	  CASE 100:
	       {
	       WAIT 100 'SERVER_ERR_DELAY_RESTART' 
		    {
		    nStats[SSERV_STAT_STATE] = SERVER_STOPPED ;
		    }
	       }
	  CASE 300:
	       {
	       WAIT 300 'SERVER_ERR_DELAY_RESTART' 
		    {
		    nStats[SSERV_STAT_STATE] = SERVER_STOPPED ;
		    }
	       }
	  CASE 600:
	       {
	       WAIT 600 'SERVER_ERR_DELAY_RESTART' 
		    {
		    nStats[SSERV_STAT_STATE] = SERVER_STOPPED ;
		    }
	       }
	  CASE 3000:
	       {
	       WAIT 300 'SERVER_ERR_DELAY_RESTART' 
		    {
		    nStats[SSERV_STAT_STATE] = SERVER_STOPPED ;
		    }
	       }
	  }
     }
     
DEFINE_FUNCTION CHAR[100] fnGET_IPServer_Error(SLONG iError)
     
     {
     STACK_VAR CHAR cErrMsg[100] ;
     
     SELECT
	  {
	  ACTIVE(iError == 0):  // this won't happen here
	       {
	       cErrMsg = "'TCP Server: operation was successful'" ;
	       nStats[SSERV_STAT_STATE] = SERVER_LISTENING ;
	       nServerConAttempt = 0 ;
	       }
	  /////////////////////////////////////////////////////////////////////////
	  ACTIVE(iError == -1): // invalid server address
	       {
	       cErrMsg = "'Invalid server address'" ;
	       fnSServerRetry(600) ; 
	       }
	  ACTIVE(iError == -2): // invalid server port
	       {
	       cErrMsg = "'TCP Server: invalid server port'" ;
	       fnSServerRetry(600) ; 
	       }
	  ACTIVE(iError == -3): // invalid value for Protocol
	       {
	       cErrMsg = "'Invalid protocol'" ;
	       fnSServerRetry(600) ; 
	       }
	  ACTIVE(iError == 2): //General failure (out of memory)
	       {
	       cErrMsg = "'Invalid protocol'" ;
	       fnSServerRetry(600) ; 
	       }
	  ACTIVE(iError == 4): //Unknown host
	       {
	       cErrMsg = "'Unknown host'" ;
	       fnSServerRetry(600) ; 
	       }
	  ACTIVE(iError == 6): //Connection refused
	       {
	       cErrMsg = "'Connection refused'" ;
	       fnSServerRetry(600) ; 
	       }
	  ACTIVE(iError == 7): //Connection timed out
	       {
	       cErrMsg = "'Connection timed out'" ;
	       fnSServerRetry(600) ; 
	       }
	  ACTIVE(iError == 8): //Unknown connection error
	       {
	       cErrMsg = "'Unknown connection error'" ;
	       fnSServerRetry(600) ; 
	       }
	  ACTIVE(iError == 9): //Already closed
	       {
	       cErrMsg = "'Already closed'" ;
	       //fnSServerRetry(600) ; 
	       }
	  ACTIVE(iError == 14): //Local port already used
	       {
	       cErrMsg = "'Local port already used'" ;
	       fnSServerRetry(600) ; 
	       }
	  ACTIVE(iError == 16): //Too many open sockets
	       {
	       cErrMsg = "'Too many open socket'" ;
	       fnSServerRetry(600) ; 
	       }
	  ACTIVE(iError == 17): //Local Port Not Open
	       {
	       cErrMsg = "'Local Port Not Open'" ;
	       fnSServerRetry(600) ; 
	       }
	  ACTIVE(1): //
	       {
	       cErrMsg = "'ONERROR NO MATCH.  ERROR# ',itoa(iError)" ;
	       fnSServerRetry(600) ; 
	       }
	  }
     
     RETURN "'TCP Server: ',cErrMsg" ;
     }

DEFINE_FUNCTION CHAR fnSServer_FileWrite(CHAR iFile[])
     {                                       
     STACK_VAR SLONG nHandle ;
     STACK_VAR SLONG nResult ;
	      
     nHandle = file_open(iFile,FILE_RW_NEW) ;
     if(nHandle > 0) 
	  {
	  STACK_VAR LONG nLen ;
	  LOCAL_VAR CHAR cAttachment[SSERVER_MAX_BUFF_SIZE] ; //change to stack after testing
	  
	  cAttachment = '' ;//remove after testing
	  cAttachment = mid_string(cSServerMod_Buf,nAttachStart,(nAttachStop - nAttachStart)) ;
	  nLen = length_string(cAttachment) ;
	  fnServer_DeBug("'fnFileWrite_ToFile. file_open successful for ',iFile,' :DEBUG<',ITOA(__LINE__),'>'") ;
	  fnServer_DeBug("'fnFileWrite_ToFile. incoming buffer holds ',itoa(nLen),' bytes :DEBUG<',ITOA(__LINE__),'>'") ;
	  nResult = FILE_WRITE(nHandle,cAttachment,nLen) ;
	  if(nResult > 0) 
	       {
	       fnServer_DeBug("'fnFileWrite_ToFile. write to file OK. wrote ',itoa(nResult),' bytes! :DEBUG<',ITOA(__LINE__),'>'") ;
	       }
	  else
	       {
	       STACK_VAR CHAR cErrorMsg[56] ;
	       
	       SELECT
		    {
		    ACTIVE(nResult == '-11'):{cErrorMsg = 'disk full'} 
		    ACTIVE(nResult == '-5' ):{cErrorMsg = 'disk I/O error'}
		    ACTIVE(nResult == '-1' ):{cErrorMsg = 'invalid file handle'} 
		    ACTIVE(nResult == '-0' ):{cErrorMsg = 'zero bits returned?'}
		    }
	       fnServer_DeBug("'fnFileWrite_ToFile. ERR: ',cErrorMsg,' :DEBUG<',ITOA(__LINE__),'>'") ;
	       nResult = 0 ;
	       }
	  file_close(nHandle) ;
	  }
     else
	  {
	  STACK_VAR CHAR cErrorMsg[56] ;
	  
	  SELECT
	       {
	       ACTIVE(nHandle == '-2' ):{cErrorMsg = 'invalid file path or name'}
	       ACTIVE(nHandle == '-3' ):{cErrorMsg = 'invalid value supplied for IOFlag'}
	       ACTIVE(nHandle == '-5' ):{cErrorMsg = 'disk I/O error'} 
	       ACTIVE(nHandle == '-14'):{cErrorMsg = 'maximum number of files are already open (max 10)'}
	       ACTIVE(nHandle == '-15'):{cErrorMsg = 'Invalid file format'}
	       }
	  fnServer_DeBug("'fnFileWrite_ToFile. Bad File_Open: ',cErrorMsg,' :DEBUG<',ITOA(__LINE__),'>'") ;
	  nResult = 0 ;
	  }
     
     file_close(nHandle) ;
     if(nResult)
	  {
	  RETURN TRUE ;
	  }
     else
	  {
	  RETURN FALSE ;
	  }
     }     
    
DEFINE_FUNCTION fnParseTCP_OldLogin(CHAR iStr[])  //reference for future use....
     
     {
     (*
     if(!nLogIn_Step)
	  {
	  SEND_STRING dvServer, "'*',STR_CRLF" ;
          SELECT
	       {
	       ACTIVE(iStr == cPword):
		    {
		    REMOVE_STRING(iStr,cPword, 1) ;
		    nTCPLogged_In = 1 ;
		    SEND_STRING dvServer, "'Password accepted.',STR_CRLF" ;
		    SEND_STRING dvServer, "'*',STR_CRLF" ;
		    SEND_STRING dvServer, "'Welcome to AMX TCP server !',STR_CRLF" ;  
		    SEND_STRING dvServer, "'*',STR_CRLF" ;
	       	    }
	       ACTIVE(find_string(iStr,"'exit'", 1)):
		    {
		    REMOVE_STRING(iStr,"'exit'", 1) ;
		    SEND_STRING dvServer, "'Closing Connection !',STR_CRLF" ;
		    SEND_STRING dvServer, "'*',STR_CRLF" ;
		    SEND_STRING dvServer, "'Goodbye........'" ; 
		    WAIT 2
			 {
			 fnCloseTCPServer() ;
			 }
		    }
	       ACTIVE(find_string(iStr,"'quit'", 1)):
		    {
		    REMOVE_STRING(iStr,"'quit'", 1) ;
		    SEND_STRING dvServer, "'Closing Connection !',STR_CRLF" ; 
		    SEND_STRING dvServer, "'*',STR_CRLF" ;
		    SEND_STRING dvServer, "'Goodbye........'" ; 
		    WAIT 2
			 {
			 fnCloseTCPServer() ;
			 }
		    }
	       ACTIVE(1):
		    {
		    LOCAL_VAR INTEGER nTCP_TryCount ;
		    
		    nTCP_TryCount++ ;
			 {
			 if(nTCP_TryCount < 3)
			      {
			      SEND_STRING dvServer, "'Incorrect password, try again !',STR_CRLF" ; 
			      SEND_STRING dvServer, "'*',STR_CRLF" ;
			      SEND_STRING dvServer, "'password:'" ;
			      }
			 else
			      {
			      nTCP_TryCount = 0 ;
			      SEND_STRING dvServer, "'Three strikes, you''re out !',STR_CRLF" ; 
			      SEND_STRING dvServer, "'*',STR_CRLF" ;
			      SEND_STRING dvServer, "'Goodbye........'" ;
			      WAIT 2
				   {
				   fnCloseTCPServer() ;
				   }
			      }
			 }
		    }
	       }
	  }
     else
	  {
	  SEND_STRING dvServer, "'*',STR_CRLF" ;
	  SELECT
	       {
	       ACTIVE(iStr == "'exit'"):
		    {
		    REMOVE_STRING(iStr,"'exit'", 1) ;
		    SEND_STRING dvServer, "'Closing Connection !',STR_CRLF" ; 
		    SEND_STRING dvServer, "'*',STR_CRLF" ;
		    SEND_STRING dvServer, "'Goodbye........'" ; 
		    WAIT 2
			 {
			 fnCloseTCPServer() ;
			 }
		    }
	       ACTIVE(iStr == "'quit'"):
		    {
		    REMOVE_STRING(iStr,"'quit'", 1) ;
	            SEND_STRING dvServer, "'Closing Connection !',STR_CRLF" ;
		    SEND_STRING dvServer, "'*',STR_CRLF" ;		    
		    SEND_STRING dvServer, "'Goodbye........'" ; 
		    WAIT 2
			 {
			 fnCloseTCPServer() ;
			 }
		    }
	       ACTIVE(iStr == "'help'"):
		    {
		    SEND_STRING dvServer, "'Sorry! Help not supported yet.',STR_CRLF" ; 
		    SEND_STRING dvServer, "'*',STR_CRLF" ;
		    }
	       ACTIVE(iStr == "'?'"):
		    {
		    SEND_STRING dvServer, "'Sorry! ? not supported yet.',STR_CRLF" ;
		    SEND_STRING dvServer, "'*',STR_CRLF" ;
		    }
	       ACTIVE(1):
		    {
		    SEND_STRING dvServer, "'Unknown command: " ',iStr,' ". Check spelling & try again.',STR_CRLF" ; 
		    SEND_STRING dvServer, "'*',STR_CRLF" ;
		    }
	       }
        }
     
     RETURN ;
     *)
     }
     
DEFINE_FUNCTION fnSServProcessRX(_sSitrep iSitrepMod)
     
     {
     STACK_VAR INTEGER nFBS ;
     STACK_VAR CHAR cTask[255] ;
     
     SELECT
	  {
	  ACTIVE(find_string(iSitrepMod.cTask,'!SEND_SITREP!',1)):
	       {
	       STACK_VAR CHAR cVarToStr[8192] ;
	       
	       cVarToStr = fnSServer_VarToStr(iSitrepMod) ;
	       if(length_string(cVarToStr))
		    {
		    fnServer_DeBug("'RX_Msg, sending to main (enocoded) :DEBUG<',ITOA(__LINE__),'>'") ;
		    SEND_STRING vServer,"SSERV_TX_ENCODED,cVarToStr" ;
		    if(nAttachStart < nAttachStop)
			 {
			 fnSServer_FileWrite(iSitrepMod.cFilePath) ;
			 fnServer_DeBug("'RX_Msg, sending attachment, write to flash :DEBUG<',ITOA(__LINE__),'>'") ;
			 }
		    else
			 {
			 fnServer_DeBug("'RX_Msg, no attachment, no writing to flash :DEBUG<',ITOA(__LINE__),'>'") ;
			 }
		    fnServer_DeBug("'RX_Msg, sending to main (MSG Complete) :DEBUG<',ITOA(__LINE__),'>'") ;
		    SEND_STRING vServer,"SSERV_TX_NO_ENCODE,'!Message Complete!',STR_CRLF" ;
		    }
	       }
	  ACTIVE(1):
	       {
	       fnServer_DeBug("'SServer ProcessRX, ERR task unkown, no handler! :DEBUG<',ITOA(__LINE__),'>'") ;
	       }
	  }
     
     RETURN ;
     }
     
DEFINE_FUNCTION CHAR[4096] fnSServer_VarToStr(_sSitrep isSServerMod)
     
     {
     STACK_VAR LONG nPos ;
     STACK_VAR SINTEGER nResult;
     STACK_VAR CHAR cEncoded[4096] ;//STR_MAX_AMXMTU] ;
     
     nPos = 1 ;
     nResult = VARIABLE_TO_STRING(isSServerMod,cEncoded,nPos) ;
     if(nResult == 0)// Success
	  {
	  fnServer_DeBug("'RX_Msg, Rx VarToStr encode OK! ',itoa(length_string(cEncoded)),' byte str :DEBUG<',ITOA(__LINE__),'>'") ;
	  RETURN cEncoded ;
	  }
     else// Failure
	  {
	  fnServer_DeBug("'RX_Msg, Rx Variable To String encode ERR# (',itoa(nResult),') :DEBUG<',ITOA(__LINE__),'>'") ;
	  RETURN '' ;
	  }
     }
     
DEFINE_FUNCTION fnSITREP_StringEvent()//spare original
     
     {
     LOCAL_VAR LONG nFileLenght ;
	   
     CANCEL_WAIT 'IDLE_TIMEOUT' ;
     WAIT 300 'IDLE_TIMEOUT'
	  {
	  fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
	  fnCloseServer() ; 
	  CLEAR_BUFFER cSServerMod_Buf ;
	  }
     fnServer_DeBug("'RX_Msg, login state=(',itoa(nLogin_Step),'), DATA.TEXT=(',DATA.TEXT,') :DEBUG<',ITOA(__LINE__),'>'") ;
     SELECT
	  {
	  ACTIVE(nLogIn_Step == LOGGED_IN):
	       {
	       fnServer_DeBug("'RX_Msg, Rx (',itoa(length_string(DATA.TEXT)),') bytes, so far (',itoa(nFileLenght),') bytes :DEBUG<',ITOA(__LINE__),'>'") ;
	       SELECT
		    {
		    ACTIVE(nStats[SSERV_STAT_TYPE] == SSSERV_TYPE_SITREP):
			 {
			 LOCAL_VAR _sSitrep sSitrepMod ;
			 LOCAL_VAR CHAR cSServerRX[STR_MAX_AMXMTU] ;
			 LOCAL_VAR INTEGER nRXBody ;
			 STACK_VAR INTEGER nFBS ;
			 
			 nFileLenght = nFileLenght + length_string(DATA.TEXT) ;
			 cSServerRX = "cSServerRX,DATA.TEXT" ;
			 WHILE(find_string(cSServerRX,"STR_CRLF",1))
			      {
			      STACK_VAR CHAR cTmpStr[STR_MAX_AMXMTU] ;
			      
			      WHILE(find_string(cSServerRX,"STR_CRLF",1) == 1)
				   {
				   REMOVE_STRING(cSServerRX,"STR_CRLF",1) ;
				   }
			      if(find_string(cSServerRX,"STR_CRLF",1))
				   {
				   STACK_VAR CHAR cRemoved[128] ;
				   
				   cTmpStr = REMOVE_STRING(cSServerRX,"STR_CRLF",1) ;
				   SET_LENGTH_STRING(cTmpStr,length_string(cTmpStr) - 2) ;
				   SELECT
					{
					ACTIVE(find_string(cTmpStr,'!New Task!',1)):
					     {
					     STACK_VAR _sSitrep sZeroStruct ;
					     
					     cRemoved = REMOVE_STRING(cTmpStr,'!New Task!',1) ;
					     nAttachStart = 0 ;
					     nAttachStop = 0 ;
					     nFileLenght = 0 ;
					     nRXBody = 0 ;
					     sSitrepMod = sZeroStruct ;
					     CLEAR_BUFFER cSServerMod_Buf ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',itoa(nFileLenght),') bytes :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Task: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Task: ',1) ;
					     sSitrepMod.cTask = cTmpStr ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',sSitrepMod.cTask,') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!From: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!From: ',1) ;
					     sSitrepMod.cFrom = "cTmpStr,' : IP(',cSSourceIP,')'" ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',sSitrepMod.cFrom,') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Time: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Time: ',1) ;
					     sSitrepMod.cTime = cTmpStr ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',sSitrepMod.cTime,') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Date: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Date: ',1) ;
					     sSitrepMod.cDate = cTmpStr ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',sSitrepMod.cDate,') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Subject: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Subject: ',1) ;
					     sSitrepMod.cSubject = cTmpStr ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',sSitrepMod.cSubject,') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Body Begins: ',1)):
					     {
					     nRXBody = 1 ;
					     cRemoved = REMOVE_STRING(cTmpStr,'!Body Begins: ',1) ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(empty) :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Body Ends: ',1) || nRXBody):
					     {
					     nFBS = find_string(cTmpStr,'!Body Ends: ',1) ;
					     if(nFBS)
						  {
						  nRXBody = 0 ;
						  if(nFBS > 1)
						       {
						       sSitrepMod.cBodyText = "sSitrepMod.cBodyText,GET_BUFFER_STRING(cTmpStr,nFBS)" ;
						       }
						  cRemoved = REMOVE_STRING(cTmpStr,'!Body Ends: ',1) ;
						  fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(empty) :DEBUG<',ITOA(__LINE__),'>'") ;
						  }
					     else
						  {
						  sSitrepMod.cBodyText = "sSitrepMod.cBodyText,GET_BUFFER_STRING(cTmpStr,length_string(cTmpStr))" ;
						  }
					     }
					ACTIVE(find_string(cTmpStr,'!Message Size: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Message Size: ',1) ;
					     sSitrepMod.cMsgSize = cTmpStr ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',sSitrepMod.cMsgSize,') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Attachment Begins: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Attachment Begins: ',1) ;
					     nAttachStart = find_string(cSServerMod_Buf,'!Attachment Begins: ',1) ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(empty) :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Attachment Ends: ',1)):
					     {
					     nFBS = find_string(cTmpStr,'!Attachment Ends: ',1) ;
					     if(nFBS > 1)
						  {
						  GET_BUFFER_STRING(cTmpStr,nFBS) ;
						  }
					     cRemoved = REMOVE_STRING(cTmpStr,'!Attachment Ends: ',1) ;     
					     if(nAttachStart)
						  {
						  nAttachStop = (find_string(cSServerMod_Buf,'!Attachment Ends: ',nAttachStart) + (length_string(cRemoved) + 2)) ;
						  sSitrepMod.cFilePath = "cSServerFile[SSERVER_PATH],'\',cSServerFile[SSERVER_FILE]" ;
						  } 
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(empty) :DEBUG<',ITOA(__LINE__),'>'") ;
					     fnServer_DeBug("'RX_Msg, Rx attachment (start point ',itoa(nAttachStart),'):(end point ',itoa(nAttachStop),') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Message Complete!',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Message Complete!',1) ;  
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(empty) :DEBUG<',ITOA(__LINE__),'>'") ;					
					     fnServer_DeBug("'RX_Msg, Rx totals: nLen = (',itoa(length_string(cSServerMod_Buf)),') nFileLenght = (',itoa(nFileLenght),') :DEBUG<',ITOA(__LINE__),'>'") ;
					     fnServer_DeBug("'RX_Msg, Closing Server, sending goodbye :DEBUG<',ITOA(__LINE__),'>'") ;
					     SEND_STRING dvServer, "'Goodbye!'" ;
					     CANCEL_WAIT 'IDLE_TIMEOUT' ;
					     fnCloseServer() ;
					     fnSServProcessRX(sSitrepMod) ;
					     cTmpStr = '' ;
					     nRXBody = 0 ;
					     }
					ACTIVE(nAttachStart > nAttachStop)://attachment started but hasn't yet stopped
					     {
					     REMOVE_STRING(cTmpStr,"STR_CRLF",1) ;
					     }
					ACTIVE(1):
					     {
					     fnServer_DeBug("'RX_Msg, Rx unexpected return (',cTmpStr,') adding to body :DEBUG<',ITOA(__LINE__),'>'") ;
					     REMOVE_STRING(cTmpStr,"STR_CRLF",1) ;
					     }
					}
				   }
			      }
			 }
		    ACTIVE(nStats[SSERV_STAT_TYPE] == SSSERV_TYPE_PASSBACK):
			 {
			 SEND_STRING vServer,"DATA.TEXT" ;
			 }
		    ACTIVE(1):
			 {
			 fnServer_DeBug("'RX_Msg, unexpected server type specified str: (',DATA.TEXT,') :DEBUG<',ITOA(__LINE__),'>'") ;
			 }
		    }
	       }
	  ACTIVE(!nLogIn_Step):
	       {
	       fnServer_DeBug("'RX_Msg, nLogIn_Step = 0 ERR! :DEBUG<',ITOA(__LINE__),'>'") ;
	       SEND_STRING dvServer, "'Invalid connection!'" ;
	       fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
	       fnCloseServer() ;
	       }
	  ACTIVE(nLogIn_Step < LOGGED_IN):
	       {
	       LOCAL_VAR CHAR cSServModRX[256] ;
       
	       cSServModRX = "cSServModRX,DATA.TEXT" ;
	       CANCEL_WAIT'ENTRY2_TIMEOUT' ;
	       WAIT 100 'ENTRY2_TIMEOUT'
		    {
		    cSServModRX = '' ;
		    }
	       fnServer_DeBug("'STRING: ',cSServModRX,' :DEBUG<',ITOA(__LINE__),'>'") ;
	       SELECT
		    {
		    ACTIVE(find_string(DATA.TEXT,"STR_CRLF",1)):
			 {
			 SELECT
			      {
			      ACTIVE(nLogIn_Step == LOGIN_INIT):
				   {
				   if(find_string(cSServModRX,"cLogin[1],STR_CRLF",1))
					{
					SEND_STRING dvServer, "'password: '" ;
					nLogIn_Step = LOGIN_USER_OK ;
					}
				   else
					{
					SEND_STRING dvServer, "'Invalid User, Terminating connection!'" ;
					fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
					fnCloseServer() ;
					}
				   }
			      ACTIVE(nLogIn_Step == LOGIN_USER_OK):
				   {
				   if(find_string(cSServModRX,"cLogin[2],STR_CRLF",1))
					{
					SEND_STRING dvServer, "'welcome!'" ;
					nLogIn_Step = LOGGED_IN ;
					nFileLenght = 0 ;
					}
				   else
					{
					SEND_STRING dvServer, "'Invalid Password, Terminating connection!'" ;
					fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
					fnCloseServer() ;
					}
				   }
			      ACTIVE(cSServModRX == 'quit'):
				   {
				   SEND_STRING dvServer, "'Bye you quiter!'" ;
				   fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
				   fnCloseServer() ;
				   }
			      ACTIVE(cSServModRX == 'exit'):
				   {
				   SEND_STRING dvServer, "'See you later!'" ;
				   fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
				   fnCloseServer() ;
				   }
			      ACTIVE(1):
				   {
				   fnServer_DeBug("'ERR! Client Returned: ',DATA.TEXT,' :DEBUG<',ITOA(__LINE__),'>'") ;
				   }
			      }
			 CANCEL_WAIT'ENTRY2_TIMEOUT' ;
			 cSServModRX = '' ;
			 }
		    ACTIVE(1):
			 {
			 fnServer_DeBug("'Not Logged In, Client Returned: ',DATA.TEXT,' :DEBUG<',ITOA(__LINE__),'>'") ;
			 }
		    }
	       }
	  ACTIVE(1):
	       {
	       fnServer_DeBug("'Unknown Error!: ',DATA.TEXT,' :DEBUG<',ITOA(__LINE__),'>'") ;
	       }
	  }
     }
  
DEFINE_START    //INITIALIZE SETTING  <---------------------- CHANGER PER JOB

     {
     CREATE_BUFFER dvServer,cSServerMod_Buf ;
     
     if(LENGTH_STRING(cLogin[1]) && LENGTH_STRING(cLogin[2]))
	  {
	  nRequireLogin = 1 ;
	  }
     else
	  {
	  nRequireLogin = 2 ;
	  }
	  
     if(nStats[SSERV_STAT_AUTOSTART])
	  {
	  nStats[SSERV_STAT_STATE] = SERVER_DISABLED ;  //prevent define_program from opening server during startup wait
	  }
     WAIT 1800 'SERVER_OPEN_TIMEOUT'
	  {
	  if(nStats[SSERV_STAT_TYPE] == SSSERV_TYPE_SITREP)
	       {
	       cSServerFile[SSERVER_PATH] = 'SITREP' ;
	       cSServerFile[SSERVER_FILE] = "'SERVER_',itoa(nStats[SSERV_STAT_INSTANCE]),'.log'" ;
	       fnSServFile_Create_Dir() ;
	       }
	  if(nStats[SSERV_STAT_AUTOSTART])
	       {
	       nStats[SSERV_STAT_STATE] = SERVER_STOPPED ;
	       fnOpenServer() ;
	       }
	  }
     }
     
DEFINE_EVENT    //DATA_EVENT[dvServer]

DATA_EVENT[dvServer]
     
     {
     ONLINE:
	  {
	  cSSourceIP = DATA.SOURCEIP ;
	  nServerConAttempt = 0 ;
	  if(nStats[SSERV_STAT_DEBUG])
	       {
	       SEND_STRING 0,"13" ;
	       SEND_STRING 0,"'(***********************************************************)'" ;
	       SEND_STRING 0,"'       Sitrep Server Mod ',itoa(nStats[SSERV_STAT_INSTANCE]),', Has Client Connected           '" ;	
	       SEND_STRING 0,"'(***********************************************************)'" ;
	       SEND_STRING 0,"13" ;
	       }
	  fnServer_DeBug("'CLIENT ONLINE'") ;
	  if(nRequireLogin)
	       {
	       SEND_STRING dvServer, "'|*************************|',STR_CRLF" ;
	       SEND_STRING dvServer, "'|*** AMX SITREP SERVER ***| !---> (type exit or quit to close connection) <---!',STR_CRLF" ;
	       SEND_STRING dvServer, "'|*************************|',STR_CRLF" ;
	       SEND_STRING dvServer, "'*',STR_CRLF,'*',STR_CRLF" ;
	       SEND_STRING dvServer, "'Login Required !',STR_CRLF" ; 
	       SEND_STRING dvServer, "'*',STR_CRLF" ;
	       SEND_STRING dvServer, "'user: '" ; 
	       
	       nLogIn_Step = LOGIN_INIT ;
	       }
	  else
	       {
	       nLogIn_Step = LOGGED_IN ;
	       }
	       
	  WAIT 300 'IDLE_TIMEOUT'
	       {
	       fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
	       fnCloseServer() ; 
	       }
	  }
     OFFLINE:
	  {
	  nLogIn_Step = 0 ;
	  nServerConAttempt = 0 ;
	  fnServer_DeBug("'CLIENT OFFLINE'") ;
	  if(nStats[SSERV_STAT_STATE] == SERVER_LISTENING)//maybe shut down from client's side otherwise it's stopped already
	       {
	       fnCloseServer() ; 
	       }
	  if(nStats[SSERV_STAT_AUTOSTART] && nStats[SSERV_STAT_STATE] == SERVER_STOPPED)
	       {
	       fnOpenServer() ;
	       }
	  }
     ONERROR:
	  {
	  nLogIn_Step = 0 ;
	  fnServer_DeBug("'ONERROR: ',fnGET_IPServer_Error(TYPE_CAST(DATA.NUMBER)),' :DEBUG<',ITOA(__LINE__),'>'") ;
	  }
     STRING:
	  {
	  LOCAL_VAR LONG nFileLenght ;
	   
	  CANCEL_WAIT 'IDLE_TIMEOUT' ;
	  WAIT 300 'IDLE_TIMEOUT'
	       {
	       fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
	       fnCloseServer() ; 
	       CLEAR_BUFFER cSServerMod_Buf ;
	       }
	  //fnServer_DeBug("'RX_Msg, login state=(',itoa(nLogin_Step),'), DATA.TEXT=(',DATA.TEXT,') :DEBUG<',ITOA(__LINE__),'>'") ;
	  SELECT
	       {
	       ACTIVE(nLogIn_Step == LOGGED_IN):
		    {
		    //fnServer_DeBug("'RX_Msg, Rx (',itoa(length_string(DATA.TEXT)),') bytes, so far (',itoa(nFileLenght),') bytes :DEBUG<',ITOA(__LINE__),'>'") ;
		    SELECT
			 {
			 ACTIVE(nStats[SSERV_STAT_TYPE] == SSSERV_TYPE_SITREP):
			      {
			      LOCAL_VAR _sSitrep sSitrepMod ;
			      LOCAL_VAR CHAR cSServerRX[8192] ;
			      LOCAL_VAR INTEGER nRXBody ;
			      STACK_VAR INTEGER nFBS ;
			      
			      nFileLenght = nFileLenght + length_string(DATA.TEXT) ;
			      cSServerRX = "cSServerRX,DATA.TEXT" ;
			      WHILE(find_string(cSServerRX,"STR_CRLF",1))
				   {
				   STACK_VAR CHAR cTmpStr[STR_MAX_AMXMTU] ;
				   STACK_VAR CHAR cRemoved[128] ;
					
				   cTmpStr = REMOVE_STRING(cSServerRX,"STR_CRLF",1) ;
				   SELECT
					{
					ACTIVE(find_string(cTmpStr,'!Body ',1)):{}
					ACTIVE(nRXBody):{}
					ACTIVE(1):{SET_LENGTH_STRING(cTmpStr,length_string(cTmpStr) - 2)}
					}
				   SELECT
					{
					ACTIVE(find_string(cTmpStr,'!New Task!: ',1)):
					     {
					     STACK_VAR _sSitrep sZeroStruct ;
					     
					     cRemoved = REMOVE_STRING(cTmpStr,'!New Task!: ',1) ;
					     nAttachStart = 0 ;
					     nAttachStop = 0 ;
					     nFileLenght = 0 ;
					     nRXBody = 0 ;
					     sSitrepMod = sZeroStruct ;
					     CLEAR_BUFFER cSServerMod_Buf ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',itoa(nFileLenght),') bytes :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Task!: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Task!: ',1) ;
					     sSitrepMod.cTask = cTmpStr ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',sSitrepMod.cTask,') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!From!: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!From!: ',1) ;
					     sSitrepMod.cFrom = "cTmpStr,' : IP(',cSSourceIP,')'" ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',sSitrepMod.cFrom,') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Time!: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Time!: ',1) ;
					     sSitrepMod.cTime = cTmpStr ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',sSitrepMod.cTime,') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Date!: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Date!: ',1) ;
					     sSitrepMod.cDate = cTmpStr ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',sSitrepMod.cDate,') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Subject!: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Subject!: ',1) ;
					     sSitrepMod.cSubject = cTmpStr ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',sSitrepMod.cSubject,') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Body Begins!: ',1)):
					     {
					     nRXBody = 1 ;
					     cRemoved = REMOVE_STRING(cTmpStr,'!Body Begins!: ',1) ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(empty) :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Body Ends!: ',1) || nRXBody):
					     {
					     nFBS = find_string(cTmpStr,'!Body Ends!: ',1) ;
					     if(nFBS)
						  {
						  nRXBody = 0 ;
						  if(nFBS > 1)
						       {
						       sSitrepMod.cBodyText = "sSitrepMod.cBodyText,GET_BUFFER_STRING(cTmpStr,nFBS)" ;
						       }
						  cRemoved = REMOVE_STRING(cTmpStr,'!Body Ends!: ',1) ;
						  fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(empty) :DEBUG<',ITOA(__LINE__),'>'") ;
						  }
					     else
						  {
						  sSitrepMod.cBodyText = "sSitrepMod.cBodyText,GET_BUFFER_STRING(cTmpStr,length_string(cTmpStr))" ;
						  }
					     }
					ACTIVE(find_string(cTmpStr,'!Message Size!: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Message Size!: ',1) ;
					     sSitrepMod.cMsgSize = cTmpStr ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(',sSitrepMod.cMsgSize,') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Attachment Begins!: ',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Attachment Begins!: ',1) ;
					     nAttachStart = find_string(cSServerMod_Buf,'!Attachment Begins!: ',1) ;
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(empty) :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Attachment Ends!: ',1)):
					     {
					     nFBS = find_string(cTmpStr,'!Attachment Ends!: ',1) ;
					     if(nFBS > 1)
						  {
						  GET_BUFFER_STRING(cTmpStr,nFBS) ;
						  }
					     cRemoved = REMOVE_STRING(cTmpStr,'!Attachment Ends!: ',1) ;     
					     if(nAttachStart)
						  {
						  nAttachStop = (find_string(cSServerMod_Buf,'!Attachment Ends!: ',nAttachStart) + (length_string(cRemoved) + 2)) ;
						  sSitrepMod.cFilePath = "cSServerFile[SSERVER_PATH],'\',cSServerFile[SSERVER_FILE]" ;
						  } 
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(empty) :DEBUG<',ITOA(__LINE__),'>'") ;
					     fnServer_DeBug("'RX_Msg, Rx attachment (start point ',itoa(nAttachStart),'):(end point ',itoa(nAttachStop),') :DEBUG<',ITOA(__LINE__),'>'") ;
					     }
					ACTIVE(find_string(cTmpStr,'!Message Complete!',1)):
					     {
					     cRemoved = REMOVE_STRING(cTmpStr,'!Message Complete!',1) ;  
					     fnServer_DeBug("'RX_Msg, Rx (',cRemoved,'):(empty) :DEBUG<',ITOA(__LINE__),'>'") ;					
					     fnServer_DeBug("'RX_Msg, Rx totals: nLen = (',itoa(length_string(cSServerMod_Buf)),') nFileLenght = (',itoa(nFileLenght),') :DEBUG<',ITOA(__LINE__),'>'") ;
					     fnServer_DeBug("'RX_Msg, Closing Server, sending goodbye :DEBUG<',ITOA(__LINE__),'>'") ;
					     SEND_STRING dvServer, "'Goodbye!'" ;
					     CANCEL_WAIT 'IDLE_TIMEOUT' ;
					     fnCloseServer() ;
					     fnSServProcessRX(sSitrepMod) ;
					     cTmpStr = '' ;
					     nRXBody = 0 ;
					     }
					ACTIVE(nAttachStart > nAttachStop)://attachment started but hasn't yet stopped
					     {
					     REMOVE_STRING(cTmpStr,"STR_CRLF",1) ;
					     }
					ACTIVE(1):
					     {
					     fnServer_DeBug("'RX_Msg, Rx unexpected return (',cTmpStr,') adding to body :DEBUG<',ITOA(__LINE__),'>'") ;
					     REMOVE_STRING(cTmpStr,"STR_CRLF",1) ;
					     }
					}
				   }
			      }
			 ACTIVE(nStats[SSERV_STAT_TYPE] == SSSERV_TYPE_PASSBACK):
			      {
			      SEND_STRING vServer,"DATA.TEXT" ;
			      }
			 ACTIVE(1):
			      {
			      fnServer_DeBug("'RX_Msg, unexpected server type specified str: (',DATA.TEXT,') :DEBUG<',ITOA(__LINE__),'>'") ;
			      }
			 }
		    }
     	       ACTIVE(!nLogIn_Step):
		    {
		    fnServer_DeBug("'RX_Msg, nLogIn_Step = 0 ERR! :DEBUG<',ITOA(__LINE__),'>'") ;
		    SEND_STRING dvServer, "'Invalid connection!'" ;
		    fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnCloseServer() ;
		    }
	       ACTIVE(nLogIn_Step < LOGGED_IN):
		    {
		    LOCAL_VAR CHAR cSServModRX[256] ;
	    
		    cSServModRX = "cSServModRX,DATA.TEXT" ;
		    CANCEL_WAIT'ENTRY2_TIMEOUT' ;
		    WAIT 100 'ENTRY2_TIMEOUT'
			 {
			 cSServModRX = '' ;
			 }
		    fnServer_DeBug("'STRING: ',cSServModRX,' :DEBUG<',ITOA(__LINE__),'>'") ;
		    SELECT
			 {
			 ACTIVE(find_string(DATA.TEXT,"STR_CRLF",1)):
			      {
			      SELECT
				   {
				   ACTIVE(nLogIn_Step == LOGIN_INIT):
					{
					if(find_string(cSServModRX,"cLogin[1],STR_CRLF",1))
					     {
					     SEND_STRING dvServer, "'password: '" ;
					     nLogIn_Step = LOGIN_USER_OK ;
					     }
					else
					     {
					     SEND_STRING dvServer, "'Invalid User, Terminating connection!'" ;
					     fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
					     fnCloseServer() ;
					     }
				   	}
				   ACTIVE(nLogIn_Step == LOGIN_USER_OK):
					{
					if(find_string(cSServModRX,"cLogin[2],STR_CRLF",1))
					     {
					     SEND_STRING dvServer, "'welcome!'" ;
					     nLogIn_Step = LOGGED_IN ;
					     nFileLenght = 0 ;
					     }
					else
					     {
					     SEND_STRING dvServer, "'Invalid Password, Terminating connection!'" ;
					     fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
					     fnCloseServer() ;
					     }
					}
				   ACTIVE(cSServModRX == 'quit'):
					{
					SEND_STRING dvServer, "'Bye you quiter!'" ;
					fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
					fnCloseServer() ;
					}
				   ACTIVE(cSServModRX == 'exit'):
					{
					SEND_STRING dvServer, "'See you later!'" ;
					fnServer_DeBug("'RX_Msg, Closing Server :DEBUG<',ITOA(__LINE__),'>'") ;
					fnCloseServer() ;
					}
				   ACTIVE(1):
					{
					fnServer_DeBug("'ERR! Client Returned: ',DATA.TEXT,' :DEBUG<',ITOA(__LINE__),'>'") ;
					}
				   }
			      CANCEL_WAIT'ENTRY2_TIMEOUT' ;
			      cSServModRX = '' ;
			      }
			 ACTIVE(1):
			      {
			      fnServer_DeBug("'Not Logged In, Client Returned: ',DATA.TEXT,' :DEBUG<',ITOA(__LINE__),'>'") ;
			      }
			 }
		    }
	       ACTIVE(1):
		    {
		    fnServer_DeBug("'Unknown Error!: ',DATA.TEXT,' :DEBUG<',ITOA(__LINE__),'>'") ;
		    }
	       }
	  }
     }
     
DEFINE_EVENT    //DATA_EVENT[vServer]

DATA_EVENT[vServer]
     
     {
     ONLINE:
	  {
	  }
     OFFLINE:
	  {
	  }
     ONERROR:
	  {
	  }
     COMMAND:
	  {
	  fnServer_DeBug("'Virtual RX Cmd: (',DATA.TEXT,') :DEBUG<',ITOA(__LINE__),'>'") ;
	  SELECT
	       {
	       ACTIVE(DATA.TEXT == 'START_SERVER'):
		    {
		    fnOpenServer() ;
		    }
	       ACTIVE(DATA.TEXT == 'STOP_SERVER'):
		    {
		    fnCloseServer() ;
		    }
	       ACTIVE(1):
		    {
		    fnServer_DeBug("'Unknown Command!: ',DATA.TEXT,' :DEBUG<',ITOA(__LINE__),'>'") ;
		    }
	       }
	  }
     }

DEFINE_PROGRAM

//WAIT 100
//     {
//     if(nStats[SSERV_STAT_AUTOSTART] && nStats[SSERV_STAT_STATE] == SERVER_STOPPED)
//	  {
//	  fnOpenServer() ;
//	  }
//     }

