﻿PROGRAM_NAME='VAV_SITREP_Servers'

DEFINE_DEVICE   //DEVICES DECLARED IN MAIN

//#IF_NOT_DEFINED VAV_SERVERS
//dvServer1			= 0:22:0 ;
//dvServer2			= 0:23:0 ;
//dvServer3			= 0:24:0 ;
//dvServer4			= 0:25:0 ;
//dvServer5			= 0:26:0 ;
//dvServer6			= 0:27:0 ;
//#END_IF
//
//#IF_NOT_DEFINED VAV_vSERVERS
//vServer1	    		= 33022:1:0 ;
//vServer2			= 33023:1:0 ;
//vServer3			= 33024:1:0 ;
//vServer4			= 33025:1:0 ;
//vServer5			= 33026:1:0 ;
//vServer6			= 33027:1:0 ;
//#END_IF

DEFINE_CONSTANT //GENERAL CONSTANT VALUES  <-----------------------------------------------------------REQUIRES ACTION

CHAR SSERV_NUM_SERVERS		= 4 ;//number of servers actually being used
CHAR SSERV_MAXNUM_SERVERS	= 6 ;//max number of servers this modules supports as is
CHAR SSERV_FIRST_SSERVER	= 2 ;//the first server that is used for Sitreps, all servers after this are to be Sitreps servers too
INTEGER SSERV_MAX_DATA_LENGTH   = 60000 ; 

DEFINE_CONSTANT //SERVER PORTS NEED FORWARDING IN YOUR ROUTER TO YOUR MASTER  <------------------------REQUIRES ACTION

(******************************************************************)
(*     forward these ports in your router to the masters IP       *)
INTEGER nCAMSERVER_PORT		= 1084 ; //USS McCANDLESS FF-1084
INTEGER nSSERVER_PORT		= 8101 ;
(*     forward these ports in your router to the masters IP       *)
(******************************************************************)

DEFINE_CONSTANT //STAT ARRAY ELEMENT POINTERS 

CHAR SSERV_STAT_IP_PORT		= 1 ;
CHAR SSERV_STAT_INSTANCE	= 2 ;
CHAR SSERV_STAT_STATE		= 3 ;
CHAR SSERV_STAT_ENCODE		= 4 ;
CHAR SSERV_STAT_AUTOSTART	= 5 ;
CHAR SSERV_STAT_TYPE    	= 6 ;
CHAR SSERV_STAT_DEBUG 		= 7 ;

CHAR SSSERV_TYPE_SITREP		= 1 ;
CHAR SSSERV_TYPE_PASSBACK	= 2 ;

DEFINE_CONSTANT //SERVER CONNECTIONS  //FROM VAV SYSTEM CONSTANTS

#IF_NOT_DEFINED IP_SERVER_CONSTANTS

CHAR IP_SERVER_DISABLED		= 0 ;
CHAR IP_SERVER_STOPPED		= 1 ;
CHAR IP_SERVER_PENDING		= 2 ;
CHAR IP_SERVER_LISTENING	= 3 ;
CHAR IP_SERVER_CONNECTED	= 4 ;
CHAR IP_SERVER_RX_DATA		= 5 ;
CHAR IP_SERVER_TX_DATA		= 6 ;
        
#END_IF

DEFINE_CONSTANT //SERVER DEV & vDEV ARRAYS  <----------------------------------------------------------REQUIRES ACTION

DEV dvSERVER_Arry[SSERV_NUM_SERVERS] =
     {
     dvServer1,
     dvServer2,
     dvServer3,
     dvServer4//,
     //dvServer5,
     //dvServer6
     }
     
DEV vSERVER_Arry[SSERV_NUM_SERVERS] =
     {
     vServer1,
     vServer2,
     vServer3,
     vServer4//,
     //vServer5,
     //vServer6
     }
     
DEFINE_TYPE     //_sSitrep
     
STRUCTURE _sSitrep
     
     {
     CHAR cTask[256] ;
     CHAR cFrom[256] ;
     CHAR cTIME[8] ;
     CHAR cDATE[10] ;
     CHAR cSubject[256] ;
     CHAR cMsgSize[6] ;
     CHAR cFilePath[256] ;
     CHAR cBodyText[4096] ;
     } ;  

DEFINE_VARIABLE //_sSitrep sSitrepAxi[SSERV_NUM_SERVERS] ;

VOLATILE _sSitrep sSitrepAxi[SSERV_NUM_SERVERS] ;
 
DEFINE_VARIABLE //nServer_DeBug

VOLATILE INTEGER nSServer_DeBug  	= 0 ;
//#WARN 'SERVER.axi nSServer_DeBug set to 1'

DEFINE_VARIABLE //STRUC,ARRAYs, IP & User/Pass

VOLATILE INTEGER nLstServStarted ;
VOLATILE INTEGER nSServerConAttempt[SSERV_NUM_SERVERS] ;
VOLATILE INTEGER nSServerStats[SSERV_NUM_SERVERS][7] ;     //server port,server instance,state,debug
VOLATILE CHAR    cSServerAXI_Buf[SSERV_NUM_SERVERS][8192] ;
VOLATILE CHAR    cSServerLogin[SSERV_NUM_SERVERS][2][12] ;

DEFINE_FUNCTION fnSServer_DeBug(CHAR iStr[])

     {
     if(nSServer_DeBug)
	  {
	  STACK_VAR CHAR cCopyStr[1024] ;
	  STACK_VAR INTEGER nLineCount ;
	  
	  cCopyStr = iStr ;
	  
	  nLineCount ++ ;
	  WHILE(length_string(cCopyStr) > 100)
	       {
	       SEND_STRING 0,"'SERVER.axi -,(',itoa(nLineCount),') DEBUG: ',get_buffer_string(cCopyStr,80)" ;
	       nLineCount ++
	       }
	  if(length_string(cCopyStr))
	       {
	       SEND_STRING 0,"'SERVER.axi -,(',itoa(nLineCount),') DEBUG: ',cCopyStr" ;
	       }
	  }
     
     RETURN ;
     } 
     
(*MODIFIED*)     
DEFINE_FUNCTION CHAR[SSERV_MAX_DATA_LENGTH]fnConcatString(CHAR sConcatFinal[],CHAR sConcatNew[])
     //modified from original
     {
     STACK_VAR CHAR sPieces[3];
     STACK_VAR CHAR sBuffer[SSERV_MAX_DATA_LENGTH];
     STACK_VAR LONG lPos ;
     STACK_VAR LONG lOldPos ;
 
     lpos = 1;
 
     VARIABLE_TO_STRING(sConcatFinal,sBuffer,lPos);
     sPieces[1] = sBuffer[lPos-3];
     sPieces[2] = sBuffer[lPos-2];
     sPieces[3] = sBuffer[lPos-1];
 
     lOldPos = lpos;
     lpos = lpos - 3;
 
     VARIABLE_TO_STRING(sConcatNew,sBuffer,lPos);
 
     sBuffer[lOldPos-3] = sPieces[1];
     sBuffer[lOldPos-2] = sPieces[2];
     sBuffer[lOldPos-1] = sPieces[3];

     GET_BUFFER_STRING(sBuffer,3)
 
     RETURN sBuffer ;
     }

DEFINE_FUNCTION fnSServer_SendMail(INTEGER iIndx)

     {
     STACK_VAR INTEGER nOKSend ;
	       
     nOkSend = 1 ;
     SELECT
	  {
	  ACTIVE(length_string(sSitrepAxi[iIndx].cFrom)     == 0):{nOKSend = 0}
	  ACTIVE(length_string(sSitrepAxi[iIndx].cTime)     == 0):{nOKSend = 0}
	  ACTIVE(length_string(sSitrepAxi[iIndx].cDate)     == 0):{nOKSend = 0}
	  ACTIVE(length_string(sSitrepAxi[iIndx].cSubject)  == 0):{nOKSend = 0}
	  //ACTIVE(length_string(sSitrepAxi[iIndx].cMsgSize)  == 0):{nOKSend = 0}
	  //ACTIVE(length_string(sSitrepAxi[iIndx].cBodyText) == 0):{nOKSend = 0} //we can send with out body text
	  //ACTIVE(length_string(sSitrepAxi[iIndx].cFilePath) == 0):{nOKSend = 0} //we can send with out attachment
	  }
     if(nOKsend)
	  {
	  STACK_VAR CHAR cMsgSizeStr[64] ;
	  
	  if(length_string(sSitrepAxi[iIndx].cFilePath) == 0)
	       {
	       cMsgSizeStr = 'No Attachments!' ;
	       }
	  else
	       {
	       cMsgSizeStr = "'Attachment Size: ',sSitrepAxi[iIndx].cMsgSize,' bytes!'" ;
	       }
	  fnSServer_DeBug("'RX From Mod-',itoa(iIndx),': sending email :DEBUG<',ITOA(__LINE__),'>'") ;
	
	  fnSMTP_Q_Msg(  (*FROM      *)"'MyEmail@comcast.net'",
			 (*TO        *)"'someemail@msn.com'", //add as many as require w/ ; semi-colon seperating, up to max string size defined above          		   
			 (*SUBJ      *)"'VAV Sitrep: (',TIME,'), ',sSitrepAxi[iIndx].cSubject,'!'",  
			 (*BODY      *)"'--------------> BEGIN MSG <--------------',STR_CRLF,STR_CRLF,
					'From: ',sSitrepAxi[iIndx].cFrom,STR_CRLF,STR_CRLF,
					'Report generated at: (Time-',sSitrepAxi[iIndx].cTIME,', Date-',sSitrepAxi[iIndx].cDate,').',STR_CRLF,STR_CRLF,  
					sSitrepAxi[iIndx].cBodyText,STR_CRLF,STR_CRLF,
					cMsgSizeStr,STR_CRLF,STR_CRLF,
					'---------------> END MSG <---------------',STR_CRLF",
			 (*ATTACHMENT*)"sSitrepAxi[iIndx].cFilePath"
			 ) ;
	  }
     else
	  {
	  fnSServer_DeBug("'RX From Mod-',itoa(iIndx),': sending email ERR, missing info :DEBUG<',ITOA(__LINE__),'>'") ;
	  }
	  
     RETURN ;
     }
     
DEFINE_FUNCTION fnSServerRunTask(INTEGER iIndx)

     { 
     SELECT
	  {
	  ACTIVE(find_string(sSitrepAxi[iIndx].cTask,'!SEND_SITREP!',1)):
	       {
	       fnSServer_SendMail(iIndx) ;
	       }
	  ACTIVE(1):
	       {
	       fnSServer_DeBug("'RX From Mod-',itoa(iIndx),': fnSServerRunTask ERR! (no task handler) :DEBUG<',ITOA(__LINE__),'>'") ;
	       }
	  }     
     
     RETURN ;
     }
     
DEFINE_FUNCTION fnSServerScraps() //DON'T DISCARD SAVE FOR LATER USE?
     
     {
//DEFINE_FUNCTION fnServerProcessRX(CHAR iServerRX[],INTEGER iIndx) 
//     {
//     STACK_VAR _sSitrepAxi sSitrepAxi_ ;
//     STACK_VAR INTEGER nFBS ;
//     
//     if(find_string(iServerRX,"'!Task: '",1))
//	  {
//	  REMOVE_STRING(iServerRX,"'!Task: '",1) ;
//	  nFBS = find_string(iServerRX,"STR_CRLF",1) ;
//	  if(nFBS)
//	       {
//	       sSitrepAxi[iIndx].cTask = GET_BUFFER_STRING(iServerRX,nFBS - 1) ;
//	       REMOVE_STRING(iServerRX,"'!From: '",1) ;
//	       nFBS = find_string(iServerRX,"STR_CRLF",1) ;
//	       if(nFBS)
//		    {
//		    sSitrepAxi[iIndx].cFrom = GET_BUFFER_STRING(iServerRX,nFBS - 1) ;
//		    REMOVE_STRING(iServerRX,"'!Time: '",1) ;
//		    nFBS = find_string(iServerRX,"', !DATE: '",1) ;
//		    if(nFBS)
//			 {
//			 sSitrepAxi[iIndx].cTIME = GET_BUFFER_STRING(iServerRX,nFBS - 1) ;
//			 REMOVE_STRING(iServerRX,"', !DATE: '",1) ;
//			 nFBS = find_string(iServerRX,"STR_CRLF",1) ;
//			 if(nFBS)
//			      {
//			      sSitrepAxi[iIndx].cDATE = GET_BUFFER_STRING(iServerRX,nFBS - 1) ;
//			      REMOVE_STRING(iServerRX,"'!Subject: '",1) ;
//			      nFBS = find_string(iServerRX,"STR_CRLF",1) ;
//			      if(nFBS)
//				   {
//				   sSitrepAxi[iIndx].cSubject = GET_BUFFER_STRING(iServerRX,nFBS - 1) ;
//				   REMOVE_STRING(iServerRX,"'!Message Size: '",1) ;
//				   nFBS = find_string(iServerRX,"STR_CRLF",1) ;
//				   if(nFBS)
//					{
//					sSitrepAxi[iIndx].cMsgSize = GET_BUFFER_STRING(iServerRX,nFBS - 1) ;
//					sSitrepAxi[iIndx].cBodyText = iServerRX ;
//					fnSServer_DeBug("'RX From Mod-',itoa(iIndx),': Parsing Completed! :DEBUG<',ITOA(__LINE__),'>'") ;
//				   	fnSServProcessStruct(sSitrepAxi,iIndx) ;
//					}
//				   }
//			      else
//				   {
//				   fnSServer_DeBug("'RX From Mod-',itoa(iIndx),': No "CRLF" after !Message Size: :DEBUG<',ITOA(__LINE__),'>'") ;
//				   }
//			      }
//			 else
//			      {
//			      fnSServer_DeBug("'RX From Mod-',itoa(iIndx),': No "CRLF" after !Subject: :DEBUG<',ITOA(__LINE__),'>'") ;
//			      }
//			 }
//		    else
//			 {
//			 fnSServer_DeBug("'RX From Mod-',itoa(iIndx),': No "CRLF" after !Date: :DEBUG<',ITOA(__LINE__),'>'") ;
//			 }
//		    }
//	       else
//		    {
//		    fnSServer_DeBug("'RX From Mod-',itoa(iIndx),': No ", !DATE: " after !Time: :DEBUG<',ITOA(__LINE__),'>'") ;
//		    }
//	       }
//	  else
//	       {
//	       fnSServer_DeBug("'RX From Mod-',itoa(iIndx),': No "CRLF" after !From: :DEBUG<',ITOA(__LINE__),'>'") ;
//	       }
//	  }
//     else
//	  {
//	  fnSServer_DeBug("'RX From Mod-',itoa(iIndx),': No "CRLF" after !Task: :DEBUG<',ITOA(__LINE__),'>'") ;
//	  }



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////		    
//this section was out of data event string handler keep in case!
		    
		    //STACK_VAR INTEGER nRX_EndTag ;
//		    LOCAL_VAR INTEGER nCombStrLen ;
//
//		    if(1)
//			 {
//			 nCombStrLen = (length_string(cServers_RX[nIndx]) + length_string(DATA.TEXT)) ;
//			 
//			 fnSServer_DeBug("'RX From Mod-',itoa(nIndx),': Rx Str, ( ',itoa(length_string(DATA.TEXT)),' ) bytes, so far ( ',itoa(nCombStrLen),' ) :DEBUG<',ITOA(__LINE__),'>'") ;
//			 
//			 if(find_string(DATA.TEXT,'!Message Complete!',1))
//			      {
//			      nRX_EndTag = 1 ;
//			      }
//			      
//			 if(nCombStrLen < 16000)
//			      {
//			      cServers_RX[nIndx] = "cServers_RX[nIndx],DATA.TEXT" ;
//			      }
//			 else
//			      {
//			      cServers_RX[nIndx] = fnConcatString(cServers_RX[nIndx],DATA.TEXT) ;
//			      }
//			 //cServers_RX[nIndx] = "cServers_RX[nIndx],GET_BUFFER_STRING(DATA.TEXT,length_string(DATA.TEXT))" ;
//			 }
//		    if(nRX_EndTag)
//			 {
//			 fnSServer_DeBug("'RX From Mod-',itoa(nIndx),': Rx''d Ending Tag. Msg Size=',itoa(length_string(cServers_RX[nIndx])),' bytes. Send to process. :DEBUG<',ITOA(__LINE__),'>'") ;
//			 fnServerProcessRX(cServers_RX[nIndx],nIndx) ;
//			 SWITCH(nIndx)
//			      {
//			      CASE 1:{CANCEL_WAIT 'SERVER_1_TIMEOUT'} ;
//			      CASE 2:{CANCEL_WAIT 'SERVER_2_TIMEOUT'} ;
//			      CASE 3:{CANCEL_WAIT 'SERVER_3_TIMEOUT'} ;
//			      CASE 4:{CANCEL_WAIT 'SERVER_4_TIMEOUT'} ;
//			      CASE 5:{CANCEL_WAIT 'SERVER_5_TIMEOUT'} ;
//			      CASE 6:{CANCEL_WAIT 'SERVER_6_TIMEOUT'} ;
//			      }                         
//			 }
//		    else
//			 {
//			 SWITCH(nIndx)
//			      {
//			      CASE 1:
//				   {
//				   CANCEL_WAIT 'SERVER_1_TIMEOUT' ;
//				   WAIT 300 'SERVER_1_TIMEOUT'
//					{
//					fnSServer_DeBug("'RX From Mod-',itoa(1),': ERR! No Ending tag before timeout. Dumping (',itoa(length_string(cServers_RX[1])),' bytes) recv''d :DEBUG<',ITOA(__LINE__),'>'") ;
//					cServers_RX[1] = '' ;
//					}
//				   }
//			      CASE 2:
//				   {
//				   CANCEL_WAIT 'SERVER_2_TIMEOUT' ;
//				   WAIT 300 'SERVER_2_TIMEOUT'
//					{
//					fnSServer_DeBug("'RX From Mod-',itoa(2),': ERR! No Ending tag before timeout. Dumping (',itoa(length_string(cServers_RX[2])),' bytes) recv''d :DEBUG<',ITOA(__LINE__),'>'") ;
//					cServers_RX[2] = '' ;
//					}
//				   }
//			      CASE 3:
//				   {
//				   CANCEL_WAIT 'SERVER_3_TIMEOUT' ;
//				   WAIT 300 'SERVER_3_TIMEOUT'
//					{
//					fnSServer_DeBug("'RX From Mod-',itoa(3),': ERR! No Ending tag before timeout. Dumping (',itoa(length_string(cServers_RX[3])),' bytes) recv''d :DEBUG<',ITOA(__LINE__),'>'") ;
//					cServers_RX[3] = '' ;
//					}
//				   }
//			      CASE 4:
//				   {
//				   CANCEL_WAIT 'SERVER_4_TIMEOUT' ;
//				   WAIT 300 'SERVER_4_TIMEOUT'
//					{
//					fnSServer_DeBug("'RX From Mod-',itoa(4),': ERR! No Ending tag before timeout. (',itoa(length_string(cServers_RX[4])),' bytes) recv''d :DEBUG<',ITOA(__LINE__),'>'") ;
//					cServers_RX[4] = '' ;
//					}
//				   }
//			      CASE 5:
//				   {
//				   CANCEL_WAIT 'SERVER_5_TIMEOUT' ;
//				   WAIT 300 'SERVER_5_TIMEOUT'
//					{
//					fnSServer_DeBug("'RX From Mod-',itoa(5),': ERR! No Ending tag before timeout. Dumping (',itoa(length_string(cServers_RX[5])),' bytes) recv''d :DEBUG<',ITOA(__LINE__),'>'") ;
//					cServers_RX[5] = '' ;
//					}
//				   }
//			      CASE 6:
//				   {
//				   CANCEL_WAIT 'SERVER_6_TIMEOUT' ;
//				   WAIT 300 'SERVER_6_TIMEOUT'
//					{
//					fnSServer_DeBug("'RX From Mod-',itoa(6),': ERR! No Ending tag before timeout. Dumping (',itoa(length_string(cServers_RX[6])),' bytes) recv''d :DEBUG<',ITOA(__LINE__),'>'") ;
//					cServers_RX[6] = '' ;
//					}
//				   }
//			      }
//			 }
//		    }

     RETURN ;
     }
     
DEFINE_FUNCTION SINTEGER fnSServer_StrToVar(CHAR iRX[],INTEGER iIndx)

     {
     STACK_VAR LONG nPos ;
     STACK_VAR SINTEGER nResult ;
     STACK_VAR _sSitrep sZeroStruct ;
     
     nPos = 1 ;
     nResult = STRING_TO_VARIABLE(sZeroStruct,iRX,nPos) ;
     if(nResult == 0 && iIndx)
	  {
	  sSitrepAxi[iIndx] = sZeroStruct ;
	  }
    
     RETURN nResult ;
     }
     
DEFINE_FUNCTION fnParseCameraServerRX(CHAR iStr[])  //CAMERA SERVER

     {
     STACK_VAR INTEGER nFBS ;
     STACK_VAR INTEGER nCAMERA ;
     
     fnSServer_DeBug("'RX STR: ',iStr") ;
     (*
     SELECT
	  {
	  ACTIVE(find_string(iStr,"'CAM='",1)):
	       {
	       if(!nManualBlock && !nManualBlock_5min)
		    {
		    LOCAL_VAR INTEGER nMoveInProgress ;
		    STACK_VAR INTEGER nNumCamTps ;
		    
		    REMOVE_STRING(iStr,"'CAM='",1) ;
		    nFBS = find_string(iStr,"':'",1)
		    nCAMERA = atoi("GET_BUFFER_STRING(iStr,nFBS-1)") ;
		    if(!nAxisCamBusy[nCAMERA] && !nMoveInProgress)
			 {
			 if(find_string(iStr,"'MOTION='",1))
			      {
			      STACK_VAR INTEGER i ;
			      
			      REMOVE_STRING(iStr,"'MOTION='",1) ;
			      nNumCamTps = length_array(dvAxisCam_TPArry) ;
			      for( i = 1 ; i <= nNumCamTps ; i++)//PUT ALL ON CORRECT CAMERA AND INITIATE FEEDBACK
				   {
				   SEND_COMMAND dvAxisCam_TPArry[i],"'WAKE'" ;
				   if(!nAxisCam_ActiveTPArry[i])
					{
					SEND_COMMAND dvAxisCam_TPArry[i],"'PAGE-Cameras'" ;
					}
				   if(nAxisCam_ActiveTPArry[i] != nCAMERA)//if already on just wake it
					{
					DO_PUSH (dvAxisCam_TPArry[i],100 + nCAMERA) ;
					}
				   }
			      fnSServer_DeBug("'DO PUSH FOR: ',iStr,'.   :DEBUG<<',ITOA(__LINE__),'>'") ;
			      SWITCH(iStr)
				   {
				   CASE 'UPLEFT':	{DO_PUSH (dvAxisCam_TPArry[1],17)} 
				   CASE 'UPRIGHT':	{DO_PUSH (dvAxisCam_TPArry[1],18)} 
				   CASE 'DNLEFT':	{DO_PUSH (dvAxisCam_TPArry[1],19)}
				   CASE 'DNRIGHT':	{DO_PUSH (dvAxisCam_TPArry[1],20)}
				   CASE 'LEFT':		{DO_PUSH (dvAxisCam_TPArry[1],21)}
				   CASE 'RIGHT':	{DO_PUSH (dvAxisCam_TPArry[1],22)}
				   CASE 'UP':		{DO_PUSH (dvAxisCam_TPArry[1],23)} 
				   CASE 'DOWN':		{DO_PUSH (dvAxisCam_TPArry[1],24)} 
				   CASE 'STOP':		{DO_PUSH (dvAxisCam_TPArry[1],30)} 
				   } 
			      nMotionTracking = 1 ;
			      nMoveInProgress = 1 ;
			      CANCEL_WAIT 'MOTION_TRACKING' ;
			      WAIT 30 'MOTION_TRACKING'
				   {
				   nMotionTracking = 0 ;
				   }
			      WAIT 15 'MOVE_IN_PROGRESS'
				   {
				   nMoveInProgress = 0 ;
				   }
			      }
			 }
		    }
	       }
	  ACTIVE(1):
	       {
	       //nothing for now!
	       }
	  }
     *)
     RETURN ;
     }     
     
DEFINE_FUNCTION fnSServer_StartNext(INTEGER iIndx) 

     {
     //this is just anal to rotate through all available sitrep servers
     if(iIndx < SSERV_NUM_SERVERS) 
	  {
	  if(nSServerStats[iIndx + 1][SSERV_STAT_STATE] == IP_SERVER_STOPPED &&
	       !nSServerStats[iIndx + 1][SSERV_STAT_AUTOSTART])
	       {
	       nLstServStarted = iIndx + 1 ;
	       SEND_COMMAND vSERVER_Arry[nLstServStarted],'START_SERVER' ;
	       
	       fnSServer_DeBug("'Starting SitrepServer (',itoa(nLstServStarted),') to listen on port (',itoa(nSServerStats[nLstServStarted][SSERV_STAT_IP_PORT]),') :DEBUG<',ITOA(__LINE__),'>'") ;
	       
	       RETURN ;
	       }
	  }
     if(1)//just so I can create the stack var here
	  {
	  STACK_VAR INTEGER i ;
	  
	  for(i = SSERV_FIRST_SSERVER ; i <= SSERV_NUM_SERVERS ; i ++)
	       {
	       if(nSServerStats[i][SSERV_STAT_STATE] == IP_SERVER_STOPPED && !nSServerStats[i][SSERV_STAT_AUTOSTART]) //stopped and not autostart
		    {
		    nLstServStarted = i ;
		    SEND_COMMAND vSERVER_Arry[nLstServStarted],'START_SERVER' ;
		    
		    fnSServer_DeBug("'Starting SitrepServer (',itoa(nLstServStarted),') to listen on port (',itoa(nSServerStats[nLstServStarted][SSERV_STAT_IP_PORT]),') :DEBUG<',ITOA(__LINE__),'>'") ;
		    
		    RETURN ;
		    }
	       }
	  }
     //Hmmm? Nothing available to start, oh well!
     fnSServer_DeBug("'No additional SitrepServer available for listening. ',itoa(SSERV_NUM_SERVERS - SSERV_FIRST_SSERVER),' servers already running :DEBUG<',ITOA(__LINE__),'>'") ;
     
     RETURN ;
     }
     
DEFINE_FUNCTION fnSServer_StopExtras(INTEGER iIndx) //stop all listening servers but one

     {
     STACK_VAR INTEGER i ;
     
     for(i = SSERV_FIRST_SSERVER ; i <= SSERV_NUM_SERVERS ; i ++)
	  {
	  if(i == iIndx)
	       {
	       fnSServer_DeBug("'SitrepServer (',itoa(i),') last started, left to listen :DEBUG<',ITOA(__LINE__),'>'") ;
	       }
	  else if(nSServerStats[i][SSERV_STAT_STATE] == IP_SERVER_LISTENING)
	       {
	       if(nSServerStats[i][SSERV_STAT_AUTOSTART] == 1) 
		    {
		    fnSServer_DeBug("'SitrepServer (',itoa(i),') listening and set to "auto connect", leaving alone :DEBUG<',ITOA(__LINE__),'>'") ;
		    }
	       else//shut down all listening other that the last to disco from client
		    {
		    fnSServer_DeBug("'SitrepServer (',itoa(i),') listening, sending "stop" cmd to mod (',itoa(i),') :DEBUG<',ITOA(__LINE__),'>'") ;
		    SEND_COMMAND vSERVER_Arry[i],'STOP_SERVER' ;
		    }
	       }
	  else
	       {
	       fnSServer_DeBug("'SitrepServer (',itoa(i),') not listening, do nothing :DEBUG<',ITOA(__LINE__),'>'") ;
	       }	       
	  }
     
     RETURN ;
     }

DEFINE_START    //INITIALIZE SETTINGS  <---------------------------------------------------------------REQUIRES ACTION

     {
     STACK_VAR INTEGER i ;
     
     for(i = 1 ; i <= SSERV_NUM_SERVERS ; i ++)
	  {
	  SWITCH(i)
	       {
	       CASE 1://SERVER 1  //CAMERA SERVER
		    {
		    CREATE_BUFFER vSERVER_Arry[i],cSServerAXI_Buf[i] ;
		    cSServerLogin[i][1]				= '' ;
		    cSServerLogin[i][2] 			= '' ;	    
		    nSServerStats[i][SSERV_STAT_IP_PORT] 	= nCAMSERVER_PORT ;//port for camera server to listen on
		    nSServerStats[i][SSERV_STAT_INSTANCE] 	= i ; //instance
		    nSServerStats[i][SSERV_STAT_STATE] 		= IP_SERVER_STOPPED ; //state 
		    nSServerStats[i][SSERV_STAT_ENCODE] 	= 0 ; //encode.  0 no / 1 yes
		    nSServerStats[i][SSERV_STAT_AUTOSTART] 	= 1 ; //auto start & maintain  0 no / 1 yes
		    nSServerStats[i][SSERV_STAT_TYPE] 		= 2 ; //1= sitrep, 2= just pass back
		    nSServerStats[i][SSERV_STAT_DEBUG] 		= 0 ; //debug   .
		    }
	       CASE 2://SEVER 2 //create seperate entries for each case that needs different parameters set (like above}
	       CASE 3://SEVER 3
	       CASE 4://SEVER 4
	       CASE 5://SEVER 5
	       CASE 6://SEVER 6
		    {  
		    CREATE_BUFFER vSERVER_Arry[i],cSServerAXI_Buf[i] ;
		    cSServerLogin[i][1]				= 'username' ;//username //match in Sitrep_Client.axi & DevTermLogger.axi
		    cSServerLogin[i][2] 			= 'password' ;//password  
		    nSServerStats[i][SSERV_STAT_IP_PORT] 	= nSSERVER_PORT ;//port for sitrep server to listen on
		    nSServerStats[i][SSERV_STAT_INSTANCE] 	= i ; //instance
		    nSServerStats[i][SSERV_STAT_STATE] 		= IP_SERVER_STOPPED ; //state 
		    nSServerStats[i][SSERV_STAT_ENCODE] 	= 0 ; //encode.  0 no / 1 yes
		    nSServerStats[i][SSERV_STAT_AUTOSTART] 	= 0 ; //auto start & maintain  0 no / 1 yes
		    nSServerStats[i][SSERV_STAT_TYPE] 		= 1 ; //1= sitrep, 2= just pass back
		    nSServerStats[i][SSERV_STAT_DEBUG] 		= 0 ; //debug   .
		    }
	       }
	  //#WARN 'SITREP DEF_START nSServerStats[i][SSERV_STAT_DEBUG] set to 1 in .axi'
	  if(nSServerStats[i][5])//autostart then set state to disabled
	       {
	       nSServerStats[i][3] = IP_SERVER_DISABLED ; //state 
	       }
	  }
	  
     fnSServer_StartNext(SSERV_FIRST_SSERVER -1) ;
     //use above instead so all nLastStarted are set in 1 place.
     //SEND_COMMAND vSERVER_Arry[SSERV_FIRST_SSERVER],'START_SERVER' ; //<---------------------------------
     //nLstServStarted = SSERV_FIRST_SSERVER ;
     
     
     }
     
DEFINE_MODULE  'VAV_SITREP_ServMod' SServer1(vSERVER_Arry[1],dvSERVER_Arry[1],cSServerLogin[1],nSServerStats[1])
DEFINE_MODULE  'VAV_SITREP_ServMod' SServer2(vSERVER_Arry[2],dvSERVER_Arry[2],cSServerLogin[2],nSServerStats[2])
DEFINE_MODULE  'VAV_SITREP_ServMod' SServer3(vSERVER_Arry[3],dvSERVER_Arry[3],cSServerLogin[3],nSServerStats[3])
DEFINE_MODULE  'VAV_SITREP_ServMod' SServer4(vSERVER_Arry[4],dvSERVER_Arry[4],cSServerLogin[4],nSServerStats[4])
//DEFINE_MODULE 'VAV_SITREP_ServMod' SServer5(vSERVER_Arry[5],dvSERVER_Arry[5],cSServerLogin[5],nSServerStats[5])
//DEFINE_MODULE 'VAV_SITREP_ServMod' SServer6(vSERVER_Arry[6],dvSERVER_Arry[6],cSServerLogin[6],nSServerStats[6])

DEFINE_EVENT   //DATA_EVENT[dvSERVER_Arry]

DATA_EVENT[dvSERVER_Arry]
     
     {
     ONLINE:
	  {
	  STACK_VAR INTEGER nIndx ;
	  STACK_VAR CHAR cSourceIP[15] ;
	  
	  nIndx = GET_LAST(dvSERVER_Arry) ;
	  
	  cSourceIP = DATA.SOURCEIP ;
	  nSServerStats[nIndx][SSERV_STAT_STATE] = IP_SERVER_CONNECTED ;
	  fnSServer_DeBug("'Server (',itoa(nIndx),') client is online, from IP (',cSourceIP,') :DEBUG<',ITOA(__LINE__),'>'") ;
	  fnSServer_StartNext(nIndx) ;
	  }
     OFFLINE:
	  {
	  STACK_VAR INTEGER nIndx ;
	  STACK_VAR CHAR cSourceIP[15] ;
	  
	  nIndx = GET_LAST(dvSERVER_Arry) ;
	  
	  cSourceIP = DATA.SOURCEIP ;
	  //nSServerStats[nIndx][SSERV_STAT_STATE] = IP_SERVER_LISTENING ;
	  fnSServer_DeBug("'Server (',itoa(nIndx),') client went offline, from IP (',cSourceIP,') :DEBUG<',ITOA(__LINE__),'>'") ;
	  fnSServer_StopExtras(nLstServStarted) ;
	  }
     }
     
DEFINE_EVENT   //DATA_EVENT[vSERVER_Arry]

DATA_EVENT[vSERVER_Arry]
     
     {
     ONLINE:
	  {
	  //STACK_VAR INTEGER nIndx ;
//	  
//	  nIndx = GET_LAST(dvSERVER_Arry) ;
	  }
     OFFLINE:
	  {
	 // STACK_VAR INTEGER nIndx ;
//	  
//	  nIndx = GET_LAST(dvSERVER_Arry) ;
	  }
     ONERROR:
	  {
	  //
	  }
     STRING:
	  {
	  LOCAL_VAR INTEGER nIndx ;//change back to stack after testing
	  //LOCAL_VAR CHAR cServers_RX[SSERV_NUM_SERVERS][8192] ;//remove after testing completed
	  
	  nIndx = GET_LAST(vSERVER_Arry) ;
	  
	  SWITCH(nIndx)
	       {
	       CASE 1://AXIS MOTION WINDOW SERVER
		    {
		    if(find_string(cSServerAXI_Buf[nIndx],"'"',STR_LF",1))//should only ever rx 1 at a time
			 {
			 STACK_VAR INTEGER nFBS ;
			 STACK_VAR CHAR cServers_Tmp[256] ;
			 
			 cServers_Tmp = REMOVE_STRING(cSServerAXI_Buf[nIndx],"'"',STR_LF",1) ;
			 nFBS = find_string(cServers_Tmp,"'"',STR_LF",1) ;
			 fnParseCameraServerRX(GET_BUFFER_STRING(cServers_Tmp,nFBS-1)) ;
			 }
		    //CLEAR_BUFFER cSServerAXI_Buf[nIndx] ;
		    }
	       CASE 2://SITREP SERVERS
	       CASE 3:
	       CASE 4:
	       CASE 5:
	       CASE 6:
		    {//max string from virt to main should be 31212 so all data should arrive in 1 event???
		    if(cSServerAXI_Buf[nIndx][1] == 1)
			 {
			 STACK_VAR SINTEGER nResult ;
			 
			 GET_BUFFER_CHAR(cSServerAXI_Buf[nIndx]) ;
			 fnSServer_DeBug("'RX From Mod-',itoa(nIndx),': rcv''d (',itoa(length_string(cSServerAXI_Buf[nIndx])),') encoded bytes :DEBUG<',ITOA(__LINE__),'>'") ;
			 nResult = fnSServer_StrToVar(cSServerAXI_Buf[nIndx],nIndx) ;
			 if(nResult == 0)//success
			      {
			      fnSServer_DeBug("'RX From Mod-',itoa(nIndx),': String to Var decode successful :DEBUG<',ITOA(__LINE__),'>'") ;
			      }
			 else
			      {
			      fnSServer_DeBug("'RX From Mod-',itoa(nIndx),': String to Var ERR# (',itoa(nResult),') :DEBUG<',ITOA(__LINE__),'>'") ;
			      }
			 }
		    else if(cSServerAXI_Buf[nIndx] == 0)
			 {
			 GET_BUFFER_CHAR(cSServerAXI_Buf[nIndx]) ;
			 fnSServer_DeBug("'RX From Mod-',itoa(nIndx),': rcv''d (',itoa(length_string(cSServerAXI_Buf[nIndx])),') non-encoded bytes :DEBUG<',ITOA(__LINE__),'>'") ;
			 SELECT
			      {
			      ACTIVE(find_string(cSServerAXI_Buf[nIndx],'!Message Complete!',1)):
				   {
				   fnSServer_DeBug("'RX From Mod-',itoa(nIndx),': (!Message Complete!) processing :DEBUG<',ITOA(__LINE__),'>'") ;
				   fnSServerRunTask(nIndx) ;
				   }
			      ACTIVE(1):
				   {
				   fnSServer_DeBug("'RX From Mod-',itoa(nIndx),': Unknow Str (',cSServerAXI_Buf[nIndx],') :DEBUG<',ITOA(__LINE__),'>'") ;
				   }
			      }
			 }
		    //cServers_RX[nIndx] = "cServers_RX[nIndx],cSServerAXI_Buf[nIndx]" ;//remove after testing completed
//		    CANCEL_WAIT 'DUMP_TEST_BUF' ;
//		    WAIT 300 'DUMP_TEST_BUF'
//			 {
//			 cServers_RX[nIndx] = '' ;
//			 }
		    CLEAR_BUFFER cSServerAXI_Buf[nIndx] ;
		    }
	       DEFAULT:
		    {
		    fnSServer_DeBug("'ERR String Event VServer Index=',itoa(nIndx),' :DEBUG<',ITOA(__LINE__),'>'") ;
		    }
	       }
	  }
     }
 
DEFINE_PROGRAM //EMPTY 
(***************************THE END*********************************)
(**                                                               **)
(**                                                               **)
(**                                                               **)
(**                                                               **)
(**                                                               **)
(***************************THE END*********************************)
