PROGRAM_NAME='VAV_SMTP_Out'
(***********************************************************)
(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

(***********************************************************)
(* Add this Line just above the Define_Device Section of   *)
(* your main program.                                      *)
(* #Include 'i!-EquipmentMonitorOut.axi'                   *)
(***********************************************************)
(* Use the Following list of Functions to Integrate this   *)
(* File into your program.                                 *)
(***********************************************************)

(*************************************************)
(*  Sets Your SMTP Server Name for your use.     *)
(*  use: fnSMTP_SetServer('mail.amx.com')           *)
(*                                               *)
(* fnSMTP_SetServer(CHAR Server[])                  *)
(*************************************************)
(**************************************************)
(*  Call this to send an email message            *)
(*  use: fnSMTP_Q_Msg('me@mydomain.com',        *)
(*                      'vmorrison@moondance.com' *)
(*                      'Wild Nights'             *)
(*                      'Are they calling?',      *)
(*                      '')                       *)
(*                                                *)
(* fnSMTP_Q_Msg(CHAR Source[],CHAR Dest[],      *)
(*                CHAR Subject[],CHAR Message[],  *)
(*                CHAR File[])                    *)
(**************************************************)

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)

DEFINE_DEVICE //modules that use use this code  need to be re-compiled !!!!! see list

//DevTermLogger.axs'
//VAV_!MyWeatherMod1.axs

DEFINE_CONSTANT

(*(*<---------------------------------------  SET TIMELINE CONSTANT -------------------------------->*)

TL_SMTP 		= ? ; //ADD CONTSTANT & SET VALUE IN MAIN CODE AND MODULE FILES THAT INCLUDE THIS

*)(*<---------------------------------------  SET TIMELINE CONSTANT -------------------------------->*)

SMTP_VERSION[] 		= '2.1.16'

IP_TCP          	= 1;
SMTP_PORT             	= 587 ; // 25 or yahoo alternate 465(recommended) or 587;
SMTP_SERVER_TO  	= 1200;
SMTP_URL_MAX     	= 1000;
SMTP_USER_MAX    	= 500;
SMTP_LINE_MAX    	= 256;
SMTP_MAX_EMAILS  	= 20;
SMTP_MSG_MAX     	= 4096;

SMTPIdleMode           	= 0;
SMTPLoginMode          	= 1;
SMTPFromMode           	= 2;
SMTPToMode             	= 3;
SMTPDataMode           	= 4;
SMTPMsgMode            	= 5;
SMTPQuitMode           	= 6;
SMTPCleanUp            	= 7;

SMTPAuthLoginMode      	= 8;
SMTPAuthTypeMode       	= 9;
SMTPAuthLoginNameMode  	= 10;
SMTPAuthLoginPassMode  	= 11;

// Error Codes
SMTP_RESPONSE_ERROR  	= 400;
SMTP_RESPONSE_OK     	= 250;
SMTP_RESPONSE_START  	= 354;
SMTP_TIMEOUT_ERROR   	= 1000;
SMTP_SOCKET_ERROR    	= 1001;

(* Levels *)
nTmGmtEffLevel        	= 1

(* Base64 *)
// Limits
#IF_NOT_DEFINED ENCR_MAX_ENC_LEN
ENCR_MAX_ENC_LEN      = 1000
#END_IF
#IF_NOT_DEFINED ENCR_MAX_DEC_LEN
ENCR_MAX_DEC_LEN      = 750
#END_IF

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

     STRUCTURE _sSMTP_Q //changes made here must be made also in 'VAV_SMTP_ModOut'
	  {
	  CHAR cSource[512] ;
	  CHAR cDest[512] ;
	  CHAR cSubject[256] ;
	  CHAR cMessage[4096] ;
	  CHAR cFile[256] ;
	  CHAR cTime[8] ;
	  CHAR cDate[10] ;
	  }
	  
DEFINE_TYPE //SMTP STATUS

     STRUCTURE _sStatus
	  
	  {
	  CHAR nDeBug ;
	  CHAR nConState ;
	  CHAR nConAttempts ;
	  CHAR cServer[SMTP_URL_MAX] ;
	  CHAR nServerSet ;
	  CHAR cNotifyFrom[SMTP_USER_MAX] ;
	  CHAR cNotifyTo[SMTP_USER_MAX] ;
	  CHAR cNotifySubj[SMTP_LINE_MAX] ;
	  CHAR cSysName[48] ;
	  CHAR cSource[48] ;
	  CHAR cDestination[48] ;
	  CHAR cUser[100] ;
	  CHAR cPass[100] ;
	  CHAR cTimeOffset[10] ;
	  CHAR nQHasItems ;
	  CHAR nQTLActive ;
	  CHAR nQTLReps ;
	  CHAR nQHead ;
	  CHAR nQTail ;
	  CHAR nState ;
	  CHAR nDoNext ;
	  LONG nPort ;
	  }
	  
DEFINE_TYPE //SMTP STATUS

     STRUCTURE _sSMTP
	  
	  {
	  //CHAR nDeBug ;
//	  CHAR nConState ;
//	  CHAR nConAttempts ;
//	  CHAR cServer[SMTP_URL_MAX] ;
//	  CHAR nServerSet ;
//	  CHAR cNotifyFrom[SMTP_USER_MAX] ;
//	  CHAR cNotifyTo[SMTP_USER_MAX] ;
//	  CHAR cNotifySubj[SMTP_LINE_MAX] ;
//	  CHAR cSysName[48] ;
//	  CHAR cSource[48] ;
//	  CHAR cDestination[48] ;
//	  CHAR cUser[100] ;
//	  CHAR cPass[100] ;
//	  CHAR cTimeOffset[10] ;
//	  CHAR nQHasItems ;
//	  CHAR nQTLActive ;
//	  CHAR nQTLReps ;
//	  CHAR nQHead ;
//	  CHAR nQTail ;
//	  CHAR nState ;
//	  CHAR nDoNext ;
//	  LONG nPort ;
	  _sStatus sSTAT
	  _sSMTP_Q sQUEUE[SMTP_MAX_EMAILS] ;
	  } 

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

VOLATILE _sSMTP sSMTP ;

VOLATILE CHAR cSMTP_ModBuff[8192] ;

VOLATILE CHAR nSMTP_DeBug = 0 ;
//#WARN 'nSMTP_DeBug set to 1'

VOLATILE CHAR nSMTP_AllowMail = 1 ;
VOLATILE CHAR nSMTP_ResetnQTLReps = 0 ;
VOLATILE LONG nSMTP_TL_Time[] = {1000} ;


VOLATILE INTEGER nTestEmail = 0 ;


//VOLATILE INTEGER sSMTP.sSTAT.nPort ;
//VOLATILE CHAR cSMTP_Source[48] ;
//VOLATILE CHAR sSMTP.sSTAT.cDestination[48] ;

(* SMTP Authentication *)
//VOLATILE CHAR sSMTP.sSTAT.cUser[100] ;
//VOLATILE CHAR sSMTP.sSTAT.cPass[100] ;
//
//
//// These must be set, since these are volatile they are zeroed on reboot
//VOLATILE CHAR           sSMTP.sSTAT.cServer[SMTP_URL_MAX] ;
//VOLATILE CHAR           sSMTP.sSTAT.cSysName[] = 'NetLinx' ;
//VOLATILE CHAR           sSMTP.sSTAT.nServerSet ;
//VOLATILE INTEGER        sSMTP.sSTAT.nState ;


//VOLATILE CHAR           sSMTP.sSTAT.nDoNext ;
//VOLATILE CHAR           sSMTP.sSTAT.cTimeOffset[10] ;

//VOLATILE CHAR           sSMTP.sSTAT.cNotifyFrom[SMTP_USER_MAX] ;
//VOLATILE CHAR           sSMTP.sSTAT.cNotifyTo[SMTP_USER_MAX] ;
//VOLATILE CHAR           sSMTP.sSTAT.cNotifySubj[SMTP_LINE_MAX] ;

// Queue Variables, since these are volatile they are zeroed on reboot

//VOLATILE INTEGER        sSMTP.sSTAT.nQHead ;
//VOLATILE INTEGER        sSMTP.sSTAT.nQTail ;
//VOLATILE INTEGER        nSmtpMessageToSend ;

(* Base 64 *)
VOLATILE CHAR cEncrBase64[] = {
                               'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',   //  0 to  7
                               'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',   //  8 to 15
                               'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',   // 16 to 23
                               'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',   // 24 to 31
                               'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',   // 32 to 39
                               'o', 'p', 'q', 'r', 's', 't', 'u', 'v',   // 40 to 47
                               'w', 'x', 'y', 'z', '0', '1', '2', '3',   // 48 to 55
                               '4', '5', '6', '7', '8', '9', '+', '/'    // 56 to 63
                              } ;



(****************************)
(* NAME: EncrBase64Encode   *)
(***********************************************************)
(***********************************************************)

DEFINE_FUNCTION fnSMTP_DeBug(CHAR iStr[])

     {
     if(nSMTP_DeBug)
	  {
	  STACK_VAR CHAR cCopyStr[1024] ;
	  STACK_VAR INTEGER nLineCount ;
	  
	  cCopyStr = iStr ;
	  
	  nLineCount ++ ;
	  WHILE(length_string(cCopyStr) > 100)
	       {
	       SEND_STRING 0,"'SMTP.axi (',itoa(nLineCount),') DEBUG: ',get_buffer_string(cCopyStr,80)" ;
	       nLineCount ++
	       }
	  if(length_string(cCopyStr))
	       {
	       SEND_STRING 0,"'SMTP.axi (',itoa(nLineCount),') DEBUG: ',cCopyStr" ;
	       }
	  }
     
     RETURN ;
     } 
     
DEFINE_FUNCTION CHAR[ENCR_MAX_ENC_LEN] EncrBase64Encode(CHAR cDecStr[])
     
     {
     STACK_VAR
     CHAR    cDecodeStr[ENCR_MAX_DEC_LEN] ;
     CHAR    cEncodeStr[ENCR_MAX_ENC_LEN] ;
     INTEGER nLoop ;
     INTEGER nTemp ;
     CHAR    cIdx1 ;
     CHAR    cIdx2 ;
     CHAR    cIdx3 ;
     CHAR    cIdx4 ;
     CHAR    cByte1 ;
     CHAR    cByte2 ;
     CHAR    cByte3 ;
     CHAR    cChar1 ;
     CHAR    cChar2 ;
     CHAR    cChar3 ;
     CHAR    cChar4 ;
     
     // Copy string and pad
     cDecodeStr = cDecStr
     nTemp = LENGTH_STRING(cDecodeStr) % 3
     If (nTemp <> 0)
	  {
	  cDecodeStr[LENGTH_STRING(cDecodeStr)+1] = 0 ;
	  cDecodeStr[LENGTH_STRING(cDecodeStr)+2] = 0 ;
	  cDecodeStr[LENGTH_STRING(cDecodeStr)+3] = 0 ;
	  }
     // Encode
     FOR (cEncodeStr = "", nLoop = 1; nLoop <= LENGTH_STRING(cDecodeStr); nLoop = nLoop + 3)
	  {// Get bytes
	  cByte1 = cDecodeStr[nLoop] ;
	  cByte2 = cDecodeStr[nLoop+1] ;
	  cByte3 = cDecodeStr[nLoop+2] ;
	  // Get index
	  cIdx1  =  TYPE_CAST(((cByte1 & $FC) >> 2) + 1) ;
	  cIdx2  =  TYPE_CAST((((cByte2 & $F0) >> 4) | ((cByte1 & $03) << 4)) + 1) ; 
	  cIdx3  =  TYPE_CAST((((cByte3 & $C0) >> 6) | ((cByte2 & $0F) << 2)) + 1) ;
	  cIdx4  =  TYPE_CAST(  (cByte3 & $3F) + 1) ;
	  // Get chars
	  cChar1 = cEncrBase64[cIdx1] ;
	  cChar2 = cEncrBase64[cIdx2] ;
	  cChar3 = cEncrBase64[cIdx3] ;
	  cChar4 = cEncrBase64[cIdx4] ;
	  // Pad?
	  If (LENGTH_STRING(cDecodeStr) < (nLoop+1))
	       {
	       cChar3 = $3D  ;// '='
	       }
	  If (LENGTH_STRING(cDecodeStr) < (nLoop+2))
	       {
	       cChar4 = $3D ;// '='
	       }
	  // Build string
	  cEncodeStr = "cEncodeStr, cChar1, cChar2, cChar3, cChar4" ;
	  }
	  
     RETURN cEncodeStr ;
     }


(**************************************************)
(*  Call this to configure notifications          *)
(*  use: fnSMTP_ConfigNotify('me@mydomain.com',          *)
(*                      'vmorrison@moondance.com')*)
(**************************************************)
DEFINE_FUNCTION SLONG fnSMTP_ConfigNotify(CHAR Source[],CHAR Dest[],CHAR Subject[])
     
     {
     sSMTP.sSTAT.cNotifyFrom = Source ;
     sSMTP.sSTAT.cNotifyTo   = Dest ;
     sSMTP.sSTAT.cNotifySubj = Subject ;
     }

(**************************************************)
(*  Call this to send an email message            *)
(*  use: fnSMTP_SendNotify('Are they calling?',          *)
(*                      '')                       *)
(**************************************************)
DEFINE_FUNCTION SLONG fnSMTP_SendNotify(CHAR Message[],CHAR File[])
     
     {// Debug
     fnSMTP_DeBug("'fnSMTP_SendNotify :DEBUG<',ITOA(__LINE__),'>'") ;

     // Are we full?
     If (LENGTH_STRING(sSMTP.sSTAT.cNotifyFrom) == 0 || LENGTH_STRING(sSMTP.sSTAT.cNotifyTo) == 0)
	  {
	  fnSMTP_DeBug("'Notify Not Configured...skipping notify :DEBUG<',ITOA(__LINE__),'>'") ;
	
	  Return -1 ;
	  }
     // Send
     RETURN fnSMTP_Q_Msg(sSMTP.sSTAT.cNotifyFrom,sSMTP.sSTAT.cNotifyTo,sSMTP.sSTAT.cNotifySubj,Message,File) ;
     }

(*************************************************)
(*  Sets Your SMTP Server Name for your use.     *)
(*  use: fnSMTP_SetServer('mail.amx.com')           *)
(*************************************************)
DEFINE_FUNCTION fnSMTP_SetServer(CHAR Server[])
     
     {
     CANCEL_WAIT 'CLEAR_CONNECT_PENDING'
     sSMTP.sSTAT.cServer = Server ;
     sSMTP.sSTAT.nQHead = 1 ;
     sSMTP.sSTAT.nQTail = 1 ;
     sSMTP.sSTAT.nState = SMTPIdleMode ;
     sSMTP.sSTAT.nConState = IP_CLIENT_DISCO ;
     OFF[sSMTP.sSTAT.nServerSet] ;
     If (LENGTH_STRING(Server))
	  {
	  ON[sSMTP.sSTAT.nServerSet] ;
	  }
     }

(*************************************************)
(*  Sets Your SMTP Server Name for your use.     *)
(*  use: fnSMTP_SetUser('user','pass')              *)
(*************************************************)
DEFINE_FUNCTION fnSMTP_SetUser(CHAR LogInName[],CHAR LogInPass[])
     
     {
     sSMTP.sSTAT.cUser = LogInName ;
     sSMTP.sSTAT.cPass = LogInPass ;
     }

(*************************************************)
(*  Sets Your Time Offset                        *)
(*  Include + or - in 'HHMM' format              *)
(*  use: fnSMTP_Set_TimeOffset('+1000')              *)
(*************************************************)
DEFINE_FUNCTION fnSMTP_Set_TimeOffset(CHAR Offset[])
     
     {
     sSMTP.sSTAT.cTimeOffset = Offset
     fnSMTP_DeBug("'Set Offset to "',Offset,' :DEBUG<',ITOA(__LINE__),'>'") ;
     }

(**************************************************)
(*  Call this to send an email message            *)
(*  use: fnSMTP_Q_Msg('me@mydomain.com',        *)
(*                      'vmorrison@moondance.com' *)
(*                      'Wild Nights'             *)
(*                      'Are they calling?',      *)
(*                      '')                       *)
(**************************************************)
DEFINE_FUNCTION SLONG fnSMTP_Q_Msg(CHAR Source[],CHAR Dest[],CHAR Subject[],CHAR Message[],CHAR File[])
     
     {
     sSMTP.sQUEUE[sSMTP.sSTAT.nQHead].cSource   = Source ;
     sSMTP.sQUEUE[sSMTP.sSTAT.nQHead].cDest     = Dest ;
     sSMTP.sQUEUE[sSMTP.sSTAT.nQHead].cSubject  = Subject ;
     sSMTP.sQUEUE[sSMTP.sSTAT.nQHead].cMessage  = Message ;
     sSMTP.sQUEUE[sSMTP.sSTAT.nQHead].cFile     = File ;
   
     SELECT
	  {
	  ACTIVE(sSMTP.sSTAT.nQHead == SMTP_MAX_EMAILS): 
	       {// If head is at end
	       if(sSMTP.sSTAT.nQTail <> 1) 
		    {// Don't overwrite if full
		    sSMTP.sSTAT.nQHead = 1 ;
		    }
	       }
	  ACTIVE(sSMTP.sSTAT.nQTail <> sSMTP.sSTAT.nQHead + 1): 
	       {// Don't overwrite if full
	       sSMTP.sSTAT.nQHead++ ;
	       }
	  }
     
     sSMTP.sSTAT.nQHasItems = 1 ;
     
     if(!TIMELINE_ACTIVE(TL_SMTP))
	  {
	  TIMELINE_CREATE(TL_SMTP,nSMTP_TL_Time,1,TIMELINE_ABSOLUTE,TIMELINE_REPEAT) ;
	  sSMTP.sSTAT.nQTLActive = 1 ;
	  }
         
     RETURN sSMTP.sSTAT.nQHead ;
     }

//    Debug
//     IF (nSMTP_DeBug)
//	  {
//	  SEND_STRING 0,'Que' ;
//	  }
//     // Are we full?
//     If ((sSMTP.sSTAT.nQHead - sSMTP.sSTAT.nQTail) == 1)
//	  {
//	  IF (nSMTP_DeBug)
//	       {
//	       SEND_STRING 0,'Que is full...skipping message' ;
//	       }
//	       
//	  Return -1 ;
//	  }
//     // Que up message to be sent...
//     sSMTP.sQUEUE[sSMTP.sSTAT.nQTail].cSource   = Source ;
//     sSMTP.sQUEUE[sSMTP.sSTAT.nQTail].cDest     = Dest ;
//     sSMTP.sQUEUE[sSMTP.sSTAT.nQTail].cSubject  = Subject ;
//     sSMTP.sQUEUE[sSMTP.sSTAT.nQTail].cMessage  = Message ;
//     sSMTP.sQUEUE[sSMTP.sSTAT.nQTail].cFile     = File ;
//     // Inc. tail and go
//     sSMTP.sSTAT.nQTail++ ;
//     IF (sSMTP.sSTAT.nQTail > SMTP_MAX_EMAILS)
//	  {
//	  sSMTP.sSTAT.nQTail = 1 ;
//	  }
//     Return sSMTP.sSTAT.nQTail ;
//     }

// OutGoing Command Sets
(***********************************************************)
(*************************************************)
(* Send all SMTP commands                        *)
(* use: fnSMTP_CmdSet(dvPop3Socket,2,1,"")      *)
(*************************************************)
DEFINE_FUNCTION CHAR fnSMTP_CmdSet(Dev dvSmtpSock,Integer Func, Integer MsgNum, Char Str[])
     
     {
     STACK_VAR
     CHAR cCmd[SMTP_LINE_MAX];
     SLONG slHandle;
     SLONG slReturn;
     LOCAL_VAR
     CHAR cTo[SMTP_LINE_MAX];
     CHAR cNiceTo[SMTP_LINE_MAX];
     CHAR cDate[SMTP_LINE_MAX];

     cCmd = "";
     Switch (Func)
	  {
	  CASE SMTPLoginMode:
	       {
	       cCmd = "'HELO ',Str"
	       cTo = ""
	       }
	  Case SMTPAuthLoginMode:
	       {
	       cCmd = "'EHLO ',Str"
	       cTo = ""
	       }
	  Case SMTPAuthTypeMode:
	       {
	       cCmd = "'AUTH LOGIN'"
	       cTo = ""
	       }
	  Case SMTPAuthLoginNameMode:
	       {
	       cCmd = "EncrBase64Encode(sSMTP.sSTAT.cUser)"
	       cTo = ""
	       }

	  Case SMTPAuthLoginPassMode:
	       {
	       cCmd = "EncrBase64Encode(sSMTP.sSTAT.cPass)"
	       cTo = ""
	       }

	  CASE SMTPFromMode:
	       cCmd = "'MAIL FROM: <',sSMTP.sQUEUE[MsgNum].cSource,'>'";

	  CASE SMTPToMode:
	       {
	       // Multiples
	       If (Length_String(cTo) = 0)
		    {
		    cTo = sSMTP.sQUEUE[MsgNum].cDest
		    cNiceTo = ""
		    }
	       cCmd = Remove_String(cTo,';',1)
	       If (Length_String(cCmd))
		    Set_Length_String(cCmd,Length_String(cCmd)-1)
	       Else
		    cCmd = Get_Buffer_String(cTo,Length_string(cTo))
	       cNiceTo = "cNiceTo,'<',cCmd,'>,',13,10,9"
	       cCmd = "'RCPT TO: <',cCmd,'>'";
	       }

	  CASE SMTPDataMode:
	       cCmd = "'DATA'";

	  CASE SMTPMsgMode:
	       {
	       // Debug
	       fnSMTP_DeBug("'Sending Message :DEBUG<',ITOA(__LINE__),'>'") ;

	       // Build message header
	       cNiceTo = Left_String(cNiceTo,Length_string(cNiceTo)-3)

	       // Construct an RFC2822 Date
	       cDate = "Lower_String(DAY),', ',
	       ITOA(DATE_TO_DAY(LDATE)),' ',
	       fnSMTP_ShortMonth(DATE_TO_MONTH(LDATE)),' ',
	       ITOA(DATE_TO_YEAR(LDATE)),' ',
	       TIME,' ',
	       sSMTP.sSTAT.cTimeOffset"
	       cDate[1] = cDate[1] - $20 // Upper case the first letter of Day of week

	       // Add the from, to, subject, date and soem information about us.
	       cCmd = "'From: "',sSMTP.sQUEUE[MsgNum].cSource,'" <',sSMTP.sQUEUE[MsgNum].cSource,'>',13,10"
	       SEND_STRING dvSmtpSock,"cCmd"
	       cCmd = "'To: ',cNiceTo,13,10"
	       SEND_STRING dvSmtpSock,"cCmd"
	       cCmd = "'Subject: ',sSMTP.sQUEUE[MsgNum].cSubject,13,10"
	       SEND_STRING dvSmtpSock,"cCmd"
	       cCmd = "'Date: ',cDate,13,10,
		   //'MIME-Version: 1.0',13,10,
		   'X-Mailer: i!-EquipmentMonitor ',SMTP_VERSION,13,10"
	       SEND_STRING dvSmtpSock,"cCmd"

	       // Attachement?
	       If (Length_String(sSMTP.sQUEUE[MsgNum].cFile) > 0)
		    {
		    // Only mime if we dscribe contetns and boundries
		    cCmd = "'MIME-Version: 1.0',13,10"
		    SEND_STRING dvSmtpSock,"cCmd"
		    cCmd = "'Content-Type: multipart/mixed;',13,10,
			  09,'boundary="----=_NextPart_000_0000_00000000.00000000"',13,10,13,10,
			  'This is a multi-part message in MIME format.',13,10,13,10"
		    SEND_STRING dvSmtpSock,"cCmd"
		    cCmd = "'------=_NextPart_000_0000_00000000.00000000',13,10,
			  'Content-Type: text/plain;',13,10,
			  09,'charset="iso-8859-1"',13,10,
			  'Content-Transfer-Encoding: 7bit',13,10"
		    
		    // Send it
		    SEND_STRING dvSmtpSock,"cCmd"
		    }
	       SEND_STRING dvSmtpSock,"13,10"

	       // Send message
	       While (Length_String(sSMTP.sQUEUE[MsgNum].cMessage) > SMTP_LINE_MAX)
		    {
		    cCmd = Get_Buffer_String(sSMTP.sQUEUE[MsgNum].cMessage,SMTP_LINE_MAX)
		    SEND_STRING dvSmtpSock,"cCmd"
		    }
	       cCmd = sSMTP.sQUEUE[MsgNum].cMessage
	       SEND_STRING dvSmtpSock,"cCmd,13,10"

	       // Attached file?
	       If (Length_String(sSMTP.sQUEUE[MsgNum].cFile) > 0)
		    {
		    // Debug
		    fnSMTP_DeBug("'Sending File-',sSMTP.sQUEUE[MsgNum].cFile,' :DEBUG<',ITOA(__LINE__),'>'") ;

		    // Open file
		    slHandle = File_Open(sSMTP.sQUEUE[MsgNum].cFile,1);
		    IF (slHandle < 0) 
			 fnSMTP_DeBug("'File Open Error ',ITOA(slHandle),':"',sSMTP.sQUEUE[MsgNum].cFile,'" :DEBUG<',ITOA(__LINE__),'>'") ;
			
		    If (slHandle > 0)
			 {
			 // Send attachment break
			 cCmd = "13,10,'------=_NextPart_000_0000_00000000.00000000',13,10,
				  'Content-Type: application/octet-stream;',13,10,
				  09,'name="',sSMTP.sQUEUE[MsgNum].cFile,'"'"
			 SEND_STRING dvSmtpSock,"cCmd,13,10"
			 cCmd =       "'Content-Transfer-Encoding: quoted-printable',13,10,
				  'Content-Disposition: attachment;',13,10,
				  09,'filename="',sSMTP.sQUEUE[MsgNum].cFile,'"',13,10"
			 SEND_STRING dvSmtpSock,"cCmd,13,10"
			 
			 // Send file line by line, max line size is SMTP_LINE_MAX
			 slReturn = 0;
			 While (slReturn >= 0)
			      {
			      //slReturn = File_Read_Line(slHandle,cDate,SMTP_LINE_MAX);
			      slReturn = File_Read(slHandle,cDate,256);

			      //post error messages, if exists
			      IF (slReturn < 0 && slReturn <> -9)
				   {
				   fnSMTP_DeBug("'File Read Error ',ITOA(slReturn),':"',sSMTP.sQUEUE[MsgNum].cFile,'" :DEBUG<',ITOA(__LINE__),'>'") ;
				   }

			      //send data out
			      SEND_STRING dvSmtpSock,"cDate"
			      }
			 }

		    // Send attachment break
		    cCmd = "13,10,'------=_NextPart_000_0000_00000000.00000000'"
		    SEND_STRING dvSmtpSock,"cCmd,13,10"

		    // Close file
		    slReturn = File_Close(slHandle);
		    IF (slReturn < 0) 
			 {
			 fnSMTP_DeBug("'File Close Error ',ITOA(slHandle),':"',sSMTP.sQUEUE[MsgNum].cFile,'" :DEBUG<',ITOA(__LINE__),'>'") ;
			 }
		    }

	       // Done - send this below
	       cCmd = "13,10,'.'";
	       }

	  CASE SMTPQuitMode:
	       cCmd = 'QUIT'
	  }

     // Debug
     If (Length_String(cCmd))
	  {
	  fnSMTP_DeBug("'Sending-',cCmd,' :DEBUG<',ITOA(__LINE__),'>'") ;
	  SEND_STRING dvSmtpSock,"cCmd,13,10"
	  }

     // More receipients
     If (Func == SMTPToMode && Length_String(cTo))
	  Return 0;
     Return 1;
     }
 
(*************************************************)
(* Get IP error text for a given error number    *)
(* use: fnSMTP_Get_IPError(Error)                    *)
(*************************************************)
DEFINE_FUNCTION fnSMTP_Reset()
     
     {
     CANCEL_WAIT 'CLEAR_CONNECT_PENDING'
     sSMTP.sSTAT.nState = SMTPIdleMode ;
     sSMTP.sSTAT.nConState = IP_CLIENT_DISCO ;
     }

DEFINE_FUNCTION fnSMTP_IPOpen()

     {
     sSMTP.sSTAT.nConAttempts++ ;
     sSMTP.sSTAT.nConState = IP_CLIENT_PENDING ;
     
     if(Length_String(sSMTP.sSTAT.cUser) && Length_String(sSMTP.sSTAT.cPass))
	  sSMTP.sSTAT.nState = SMTPAuthLoginMode ;
     else
	  sSMTP.sSTAT.nState = SMTPLoginMode ;
     IP_CLIENT_OPEN(dvSmtpSock.Port,sSMTP.sSTAT.cServer,SMTP_PORT,IP_TCP) ;
     
     WAIT 300 'CLEAR_CONNECT_PENDING'
	  {
	  fnSMTP_Reset() ;
	  }
  	  
     RETURN ;
     }

DEFINE_FUNCTION fnSMTP_Send_Msg_(Integer MsgNum)  // bypassed

     {
     // Debug
//     IF (nSMTP_DeBug)
//	  SEND_STRING 0,'Send'
//     
//     // Check address
//     If (LENGTH_STRING(sSMTP.sQUEUE[MsgNum].cSource) = 0)
//	  {
//	  SEND_STRING 0,'Error-Email must be from someone'
//	  Return;
//	  }
//     If (LENGTH_STRING(sSMTP.sQUEUE[MsgNum].cDest) = 0)
//	  {
//	  SEND_STRING 0,'Error-Email must be to someone'
//	  Return;
//	  }
//     IF (!sSMTP.sSTAT.nServerSet)
//	  {
//	  SEND_STRING 0,'has not been initialized'
//	  Return;
//	  }
//     IF (sSMTP.sSTAT.nState <> SMTPIdleMode)
//	  {
//	  IF (nSMTP_DeBug)
//	       SEND_STRING 0,'is busy - cannot send right now'
//	  Return;
//	  }
//     
//     // Open connection
//     nSmtpMessageToSend = MsgNum
//     IP_CLIENT_OPEN(dvSmtpSock.Port,sSMTP.sSTAT.cServer,SMTP_PORT,IP_TCP)
//     
//     If (Length_String(sSMTP.sSTAT.cUser) && Length_String(sSMTP.sSTAT.cPass))
//	  sSMTP.sSTAT.nState = SMTPAuthLoginMode
//     Else
//	  sSMTP.sSTAT.nState = SMTPLoginMode
//     
//     // Debug
//     IF (nSMTP_DeBug)
//	  SEND_STRING 0,"'Connecting-',sSMTP.sSTAT.cServer,':',ITOA(SMTP_PORT),' on ',ITOA(dvSmtpSock.Port)"
//     
//     WAIT SMTP_SERVER_TO 'Timeout'
//	  {
//	  IP_CLIENT_CLOSE(dvSmtpSock.Port)
//	  sSMTP.sSTAT.nState = SMTPIdleMode
//	  // Debug
//	  IF (nSMTP_DeBug)
//	  SEND_STRING 0,'Timeout'
//	  }
     }
//Line     16 (18:53:09):: UNKNOWN HOST: smtp.att.yahoo.com 

// Helper Functions
(***********************************************************)
(*************************************************)
(* Get IP error text for a given error number    *)
(* use: fnSMTP_Get_IPError(Error)                    *)
(*************************************************)
DEFINE_FUNCTION CHAR[100] fnSMTP_Get_IPError (LONG lERR)
     
     {
     Switch (lERR)
	  {
	  Case 0:
	       RETURN "";
	  Case 2:
	       RETURN "'IP ERROR (',ITOA(lERR),'): General Failure (IP_CLIENT_OPEN/IP_SERVER_OPEN)'";
	  Case 4:
	       RETURN "'IP ERROR (',ITOA(lERR),'): unknown host (IP_CLIENT_OPEN)'";
	  Case 6:
	       RETURN "'IP ERROR (',ITOA(lERR),'): connection refused (IP_CLIENT_OPEN)'";
	  Case 7:
	       RETURN "'IP ERROR (',ITOA(lERR),'): connection timed out (IP_CLIENT_OPEN)'";
	  Case 8:
	       RETURN "'IP ERROR (',ITOA(lERR),'): unknown connection error (IP_CLIENT_OPEN)'";
	  Case 14:
	       RETURN "'IP ERROR (',ITOA(lERR),'): local port already used (IP_CLIENT_OPEN/IP_SERVER_OPEN)'";
	  Case 16:
	       RETURN "'IP ERROR (',ITOA(lERR),'): too many open sockets (IP_CLIENT_OPEN/IP_SERVER_OPEN)'";
	  Case 10:
	       RETURN "'IP ERROR (',ITOA(lERR),'): Binding error (IP_SERVER_OPEN)'";
	  Case 11:
	       RETURN "'IP ERROR (',ITOA(lERR),'): Listening error (IP_SERVER_OPEN)'";
	  Case 15:
	       RETURN "'IP ERROR (',ITOA(lERR),'): UDP socket already listening (IP_SERVER_OPEN)'";
	  Case 9:
	       RETURN "'IP ERROR (',ITOA(lERR),'): Already closed (IP_CLIENT_CLOSE/IP_SERVER_CLOSE)'";
	  Default:
	       RETURN "'IP ERROR (',ITOA(lERR),'): Unknown'";
	  }
     }

(*****************************)
(* FUNCTION: LONG_MONTH_NAME*)
(***********************************************************)
(***********************************************************)
DEFINE_FUNCTION CHAR[20] fnSMTP_ShortMonth (SINTEGER snMONTH)
     
     {
     SWITCH (snMonth)
	  {
	  CASE 1:  RETURN 'Jan';
	  CASE 2:  RETURN 'Feb';
	  CASE 3:  RETURN 'Mar';
	  CASE 4:  RETURN 'Apr';
	  CASE 5:  RETURN 'May';
	  CASE 6:  RETURN 'Jun';
	  CASE 7:  RETURN 'Jul';
	  CASE 8:  RETURN 'Aug';
	  CASE 9:  RETURN 'Sep';
	  CASE 10: RETURN 'Oct';
	  CASE 11: RETURN 'Nov';
	  CASE 12: RETURN 'Dec';
	  }
     RETURN "";
     }
(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

CREATE_BUFFER vSMTP_Mod,cSMTP_ModBuff ;
//WAIT 600
//     {
     sSMTP.sSTAT.cSysName 	= 'NetLinx' ;
     sSMTP.sSTAT.nPort 		= SMTP_PORT ;
     sSMTP.sSTAT.cSource 	= 'MyEmail@comcast.net' ;
     sSMTP.sSTAT.cDestination 	= 'someemail@msn.com' ;
     fnSMTP_DeBug("'i!-EquipmentMonitorOut (Smtp) Version ',SMTP_VERSION,' :DEBUG<',ITOA(__LINE__),'>'") ;
     fnSMTP_SetServer('smtp.comcast.net')// mail.optonline.net  for smtp and pop3
     fnSMTP_SetUser('smtp_user','smtp_pass')  // include only if you need SMTP authentication
     fnSMTP_Set_TimeOffset('-0600')
     fnSMTP_ConfigNotify('MyEmail@comcast.net','someemail@msn.com','VAV Notificatioins')
//     }
sSMTP.sSTAT.nConState = IP_CLIENT_DISABLED ;
WAIT 600
     {
     sSMTP.sSTAT.nConState = IP_CLIENT_DISCO ;
     }
(***********************************************************)
(*                THE EVENTS GOES BELOW                    *)
(***********************************************************)
DEFINE_EVENT    //DATA_EVENT[dvSmtpSock]

DATA_EVENT[dvSmtpSock]

     {
     ONLINE:
	  {
	  fnSMTP_DeBug("'ONLINE :DEBUG<',ITOA(__LINE__),'>'") ;
	  
//	  sSMTP.sSTAT.nQTLReps = 0 ;
//	  sSMTP.sSTAT.nConAttempts = 0 ;
	  sSMTP.sSTAT.nConState = IP_CLIENT_CONNECTED ;
	  
	  CANCEL_WAIT 'SMTP_AUTO_CLOSE' ;
	  WAIT 300 'SMTP_AUTO_CLOSE'
	       {
	       if(sSMTP.sSTAT.nConState != IP_CLIENT_DISABLED)
		    {
		    fnSMTP_DeBug("'ONLINE AUTO CLOSE, closing :DEBUG<',ITOA(__LINE__),'>'") ;
		    IP_CLIENT_CLOSE(dvSmtpSock.Port)
		    //fnSMTP_Reset();
		    }
	       }
	  }

     OFFLINE:
	  {
	  CANCEL_WAIT 'SMTP_AUTO_CLOSE' ;
	  CANCEL_WAIT 'CLEAR_CONNECT_PENDING' ;
	  
	  fnSMTP_DeBug("'OFFLINE :DEBUG<',ITOA(__LINE__),'>'") ;
	  
	  if(sSMTP.sSTAT.nConState == IP_CLIENT_DEVICE_READY)
	       {
	       sSMTP.sSTAT.nQTLReps = 0 ;
	       sSMTP.sSTAT.nConAttempts = 0 ;
	       }
	  fnSMTP_Reset();
	  }

     ONERROR:
	  {
	  CANCEL_WAIT 'SMTP_AUTO_CLOSE' ;
	  
	  sSMTP.sSTAT.nConState = IP_CLIENT_DISCO ;
	  
	  IF (Data.Number <> 9)
	       fnSMTP_DeBug("'OnError-',fnSMTP_Get_IPError(Data.Number),' :DEBUG<',ITOA(__LINE__),'>'") ;
	  SWITCH (Data.Number)
	       {
	       (* STUFF WE CANNOT DO MUCH ABOUT! *)
	       CASE 14: {} (* local port already used (IP_CLIENT_OPEN/IP_SERVER_OPEN) *)
	       CASE 16: {} (* too many open sockets (IP_CLIENT_OPEN/IP_SERVER_OPEN) *)
	       CASE 10: {} (* Binding error (IP_SERVER_OPEN) *)
	       CASE 11: {} (* Listening error (IP_SERVER_OPEN) *)
	       CASE 15: {} (* UDP socket already listening (IP_SERVER_OPEN) *)
	       CASE  9: {} (* Already closed (IP_CLIENT_CLOSE/IP_SERVER_CLOSE) *)
	       CASE  8: {} (* unknown connection error (IP_CLIENT_OPEN) *)
	       CASE  2: {} (* General Failure (IP_CLIENT_OPEN/IP_SERVER_OPEN) *)
	       CASE  4:    (* unknown host (IP_CLIENT_OPEN) *)
		    fnSMTP_DeBug("'Things To Try:  Make sure the DNS entries are entered for this master. :DEBUG<',ITOA(__LINE__),'>'") ;
	       CASE  6:    (* connection refused (IP_CLIENT_OPEN) *)
		    fnSMTP_DeBug("'Things To Try:  The server does not appear to be a SMTP server (i.e. not listening at port ',ITOA(SMTP_PORT),') :DEBUG<',ITOA(__LINE__),'>'") ;
	       CASE  7:    (* connection timed out (IP_CLIENT_OPEN) *)
		    fnSMTP_DeBug("'Things To Try:  The server appears to be offline. :DEBUG<',ITOA(__LINE__),'>'") ;
	       }
	  fnSMTP_Reset();
	  }

     STRING:
	  {
	  STACK_VAR CHAR cInBuffer[1000]
	  STACK_VAR CHAR cInCmd[200]
	  STACK_VAR INTEGER nFound
	  
	  CANCEL_WAIT 'SMTP_AUTO_CLOSE' ;
	  WAIT 300 'SMTP_AUTO_CLOSE'
	       {
	       if(sSMTP.sSTAT.nConState != IP_CLIENT_DISABLED)
		    {
		    fnSMTP_DeBug("'ONLINE AUTO CLOSE, closing :DEBUG<',ITOA(__LINE__),'>'") ;
		    IP_CLIENT_CLOSE(dvSmtpSock.Port)
		    //fnSMTP_Reset();
		    }
	       }
	  
	  IF ((nSMTP_DeBug) || (ATOI(Data.Text) >= SMTP_RESPONSE_ERROR))
	       {
	       cInBuffer = DATA.TEXT
	       nFound = FIND_STRING(cInBuffer,"10",1)
	       IF(nFound)
		    {
		    WHILE(nFound)
			 {
			 //extract first command from buffer
			 cInCmd = LEFT_STRING(cInBuffer,nFound-2)  //-2 to remove the <CR,LF>
			 cInBuffer = RIGHT_STRING(cInBuffer, LENGTH_STRING(cInBuffer) - nFound)

			 //post debug message
			 fnSMTP_DeBug("'Receive-',cInCmd,' :DEBUG<',ITOA(__LINE__),'>'") ;

			 //find next occurance
			 nFound = FIND_STRING(cInBuffer,"10",1)
			 }
		    }
	       ELSE
		    {
		    //post debug message
		    fnSMTP_DeBug("'Receive-',cInBuffer,' :DEBUG<',ITOA(__LINE__),'>'") ;
		    }
	       }

	  // Any errors
	  if(ATOI(Data.Text) >= SMTP_RESPONSE_ERROR)
	       {
	       IP_CLIENT_CLOSE(dvSmtpSock.Port)
	       sSMTP.sSTAT.nState = SMTPIdleMode
(**)	       //nSMTP_AllowMail = 0 
	       }
	  else
	       {
	       fnSMTP_DeBug("'Negotiating step-',itoa(sSMTP.sSTAT.nState),' :DEBUG<',ITOA(__LINE__),'>'") ;
	       SWITCH(sSMTP.sSTAT.nState)
		    {
		    // Idle, do nothing
		    CASE SMTPIdleMode: //0
			 {}
		    CASE SMTPLoginMode://1 	
		    CASE SMTPAuthLoginMode://8
		    CASE SMTPAuthTypeMode://9 
		    CASE SMTPAuthLoginNameMode://10
		    CASE SMTPAuthLoginPassMode://11	
			 {
			 sSMTP.sSTAT.nDoNext = fnSMTP_CmdSet(dvSmtpSock,sSMTP.sSTAT.nState,0,sSMTP.sSTAT.cSysName) ;
			 }
		    CASE SMTPFromMode://2
		    CASE SMTPToMode://3   	
		    CASE SMTPDataMode://4  	
		    CASE SMTPMsgMode://5 
		    CASE SMTPQuitMode://6		    
			 {
			 if(sSMTP.sSTAT.nState == SMTPFromMode)
			      {//long is was succesful so set ready and clear counters
			      CANCEL_WAIT 'CLEAR_CONNECT_PENDING' ;
			      sSMTP.sSTAT.nConState = IP_CLIENT_DEVICE_READY ;
			      }
			 sSMTP.sSTAT.nDoNext = fnSMTP_CmdSet(dvSmtpSock,sSMTP.sSTAT.nState,sSMTP.sSTAT.nQTail,"") ;
			 
			 if(sSMTP.sSTAT.nState == SMTPQuitMode)
			      {//made it through successfully so advance QTail		
			      SELECT 
				   {
				   ACTIVE(sSMTP.sSTAT.nQTail == SMTP_MAX_EMAILS):// Rollover
					sSMTP.sSTAT.nQTail = 1 ;                 //
				   ACTIVE(1):                                    // or 
					sSMTP.sSTAT.nQTail++ ;			 // Increment
				   }
				   
			      if(sSMTP.sSTAT.nQTail == sSMTP.sSTAT.nQHead)
				   sSMTP.sSTAT.nQHasItems = 0 ;
			      }
			 }
		    CASE SMTPCleanUp://7
			 {
			 IP_CLIENT_CLOSE(dvSmtpSock.Port) ;//let the offline event reset/clean up
			 }
		    }
	       // Increment state if not idle
	       If (sSMTP.sSTAT.nState == SMTPAuthLoginPassMode)
		    {
		    sSMTP.sSTAT.nState = SMTPLoginMode ;
		    fnSMTP_DeBug("'Next step-',itoa(sSMTP.sSTAT.nState),' :DEBUG<',ITOA(__LINE__),'>'") ;
		    }
	       If (sSMTP.sSTAT.nState <> SMTPIdleMode && sSMTP.sSTAT.nDoNext)
		    {
		    sSMTP.sSTAT.nState++
		    fnSMTP_DeBug("'Next step-',itoa(sSMTP.sSTAT.nState),' :DEBUG<',ITOA(__LINE__),'>'") ;
		    }
	       }
	  }
     }

DEFINE_EVENT    //DATA_EVENT[vSitrep_Client]

DATA_EVENT[vSMTP_Mod]		
     
     {
     ONLINE: 
	  {
	  fnSMTP_DeBug("'vSitrep_Client Online! :DEBUG<',ITOA(__LINE__),'>'") ;
	  }
     OFFLINE: 
	  {
	  fnSMTP_DeBug("'vSitrep_Client Offline! :DEBUG<',ITOA(__LINE__),'>'") ;
	  }
     ONERROR:
	  {
	  fnSMTP_DeBug("'vSitrep_Client OnError! ERR# (',itoa(DATA.NUMBER),') :DEBUG<',ITOA(__LINE__),'>'") ;
	  }
     STRING: 
	  {
	  if(cSMTP_ModBuff[1] == 1)
	       {
	       STACK_VAR _sSMTP_Q sSMTP_Q_Mod ;
	       STACK_VAR SINTEGER nResult ;
	       STACK_VAR INTEGER nLenBuf ;
	       STACK_VAR LONG nPos ;
	       
	       GET_BUFFER_CHAR(cSMTP_ModBuff) ;
	       nLenBuf = length_string(cSMTP_ModBuff) ;
	     
	       nPos = 1 ;
	       nResult = STRING_TO_VARIABLE(sSMTP_Q_Mod,cSMTP_ModBuff,nPos) ;
	       if(nResult == 0)
		    {
		    fnSMTP_DeBug("'RX rcv''d (',itoa(nLenBuf),') encoded bytes, decode successfull :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSMTP_DeBug("'RX Task (',sSMTP_Q_Mod.cDate,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSMTP_DeBug("'RX Task (',sSMTP_Q_Mod.cSource,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSMTP_DeBug("'RX Task (',sSMTP_Q_Mod.cDest,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSMTP_DeBug("'RX Task (',sSMTP_Q_Mod.cSubject,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSMTP_DeBug("'RX Task (',sSMTP_Q_Mod.cMessage,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    fnSMTP_DeBug("'RX Task (',sSMTP_Q_Mod.cFile,') :DEBUG<',ITOA(__LINE__),'>'") ;
		    		    
		    fnSMTP_Q_Msg(  (*src email*)sSMTP_Q_Mod.cSource,
				   (*to       *)sSMTP_Q_Mod.cDest,
				   (*subject  *)sSMTP_Q_Mod.cSubject, 
				   (*message  *)sSMTP_Q_Mod.cMessage,
				   (*file     *)sSMTP_Q_Mod.cFile) ;
			    
				   //sSMTP_Q_Mod.cTime   //set in qeue msg to current time
				   //sSMTP_Q_Mod.cLDate  //set in qeue msg to current date
		    }
	       else
		    {
		    fnSMTP_DeBug("'RX rcv''d (',itoa(nLenBuf),') encoded bytes, decode failed (',itoa(nResult),') :DEBUG<',ITOA(__LINE__),'>'") ;
		    }
	       }
	  else
	       {
	       STACK_VAR INTEGER nLenBuf ;
	       nLenBuf = length_string(cSMTP_ModBuff) ;
	       
	       fnSMTP_DeBug("'RX rcv''d (',itoa(nLenBuf),') bytes: ',cSMTP_ModBuff,' :DEBUG<',ITOA(__LINE__),'>'") ;
	       }
	  
	  cSMTP_ModBuff = '' ;
	  }
     }
(*************************************************)
(*  Level event for i!-TimeManager effective GMT *)
(*************************************************)
#IF_DEFINED vdvTmEvents
LEVEL_EVENT[vdvTmEvents,nTmGmtEffLevel]
     
     {
     STACK_VAR
     INTEGER nTempOffsetHour
     INTEGER nTempOffsetMin
     CHAR    cOffset[20]

     // Now, i!-TimeManager's offset is a float in hours.  We need to convert to "+/-HHMM" format
     nTempOffsetHour = ABS_VALUE(LEVEL.VALUE)
     nTempOffsetMin  = ((ABS_VALUE(LEVEL.VALUE) * 100) % 100) * 60 / 100
     cOffset = "FORMAT('%02d',nTempOffsetHour),FORMAT('%02d',nTempOffsetMin)"
     IF (LEVEL.VALUE > 0)
	  cOffset = "'+',cOffset"
     ELSE
	  cOffset = "'-',cOffset"

     fnSMTP_Set_TimeOffset(cOffset)
     }
#END_IF


DEFINE_EVENT    //TIMELINE_EVENT[TL_1]

TIMELINE_EVENT[TL_SMTP]  //1000ms repeating
     
     {
     if(nSMTP_ResetnQTLReps)//testing to reset count
	  {
	  sSMTP.sSTAT.nConAttempts = 0 ;
	  sSMTP.sSTAT.nQTLReps  = 0 ;
	  nSMTP_ResetnQTLReps = 0 ;
	  }
     if(nSMTP_AllowMail)
	  {
	  if(sSMTP.sSTAT.nQHasItems && sSMTP.sSTAT.nConState == IP_CLIENT_DISCO && sSMTP.sSTAT.nState == SMTPIdleMode) 
	       {
	       sSMTP.sSTAT.nQTLReps++ ;//used instead of timeline.reption
	       SELECT
		    {
		    ACTIVE(sSMTP.sSTAT.nConAttempts == 0)://just send
			 {
			 fnSMTP_DeBug("'Connect attempt:(',itoa(sSMTP.sSTAT.nConAttempts +1),'), SMTP Server: ',sSMTP.sSTAT.cServer,', no delay :DEBUG <',ITOA(__LINE__),'>'") ;
			 fnSMTP_IPOpen() ;
			 }
		    ACTIVE(sSMTP.sSTAT.nConAttempts <= 5)://every 10 seconds
			 {
			 if(sSMTP.sSTAT.nQTLReps % 10 == 0)
			      {
			      fnSMTP_DeBug("'Connect attempt:(',itoa(sSMTP.sSTAT.nConAttempts +1),'), SMTP Server: ',sSMTP.sSTAT.cServer,', @ 10s delay :DEBUG <',ITOA(__LINE__),'>'") ;
			      fnSMTP_IPOpen() ;
			      }
			 }
		    ACTIVE(sSMTP.sSTAT.nConAttempts <= 10)://every 30 seconds
			 {
			 if(sSMTP.sSTAT.nQTLReps % 30 == 0)
			      {
			      fnSMTP_DeBug("'Connect attempt:(',itoa(sSMTP.sSTAT.nConAttempts +1),'), SMTP Server: ',sSMTP.sSTAT.cServer,', @ 30s delay :DEBUG <',ITOA(__LINE__),'>'") ;
			      fnSMTP_IPOpen() ;
			      }
			 }
		    ACTIVE(sSMTP.sSTAT.nConAttempts <= 15)://every 5 minutes
			 {
			 if(sSMTP.sSTAT.nQTLReps % 300 == 0)
			      {
			      fnSMTP_DeBug("'Connect attempt:(',itoa(sSMTP.sSTAT.nConAttempts +1),'), SMTP Server: ',sSMTP.sSTAT.cServer,', @ 5m delay :DEBUG <',ITOA(__LINE__),'>'") ;
			      fnSMTP_IPOpen() ;
			      }
			 }
		    ACTIVE(1)://once an hours 
			 {
			 if(sSMTP.sSTAT.nQTLReps % 3600 == 0)
			      {
			      fnSMTP_DeBug("'Connect attempt:(',itoa(sSMTP.sSTAT.nConAttempts +1),'), SMTP Server: ',sSMTP.sSTAT.cServer,', @ 1h delay :DEBUG <',ITOA(__LINE__),'>'") ;
			      fnSMTP_IPOpen() ;
			      }
			 }
		    }
	       }
	  }
     else if(!sSMTP.sSTAT.nQHasItems)
	  {
	  if(TIMELINE_ACTIVE(TL_SMTP))
	       {
	       fnSMTP_DeBug("'TIMELINE_EVENT - Q Empty, Killing Timeline :DEBUG <',ITOA(__LINE__),'>'") ;
	       TIMELINE_KILL(TL_SMTP) ;
	       sSMTP.sSTAT.nQTLActive = 0 ;//just for debugging info
	       }
	  }
     if(sSMTP.sSTAT.nQTLReps == 3600)//reset keep count reasonable
	  {
	  sSMTP.sSTAT.nQTLReps = 0 ;
	  }
     }
     
DEFINE_PROGRAM

// If an email in the Q send it

//WAIT 50
//     {
//     if(sSMTP.sSTAT.nQHasItems) // && sSMTP.sSTAT.nConState == IP_CLIENT_DISCO && sSMTP.sSTAT.nState = SMTPIdleMode)
//	  {
//	  fnSMTP_IPOpen() ;
//	  }
//	//	    fnSMTP_Send_Msg(sSMTP.sSTAT.nQHead)
//		    // Bump que
//		    sSMTP.sSTAT.nQHead++
//		    IF (sSMTP.sSTAT.nQHead > SMTP_MAX_EMAILS) 
//			 sSMTP.sSTAT.nQHead=1
//		    }
//	       }
//	  }
//    }

if(nTestEmail)
     {
     fnSMTP_Q_Msg(sSMTP.sSTAT.cSource,                                                  //from
			 "sSMTP.sSTAT.cDestination,';2034705456@vtext.com '",  //to sbeiglw@optonline.net;sbeiglw@att.blackberry.net;2034446578@txt.att.net;       
			 "'VAV Office Test (',TIME,'), AMX Notifications!'",  //subject
			 "'AMX Email Test. * ',TIME,' on ',LDATE,' *',$0D,$0A,         
			   
			 'source  = ',sSMTP.sSTAT.cSource,$0D,$0A,
			 'destination  = ',sSMTP.sSTAT.cDestination,$0D,$0A,
			 'port = ',itoa(sSMTP.sSTAT.nPort),$0D,$0A,
			  $0D,$0A,$0D,$0A,
			  '*********THE END*********',$0D,$0A",             //MSG body
			 '') ; 
			 
	       SEND_STRING 0,"'Sending email.  Testing!    <-Line-<',ITOA(__LINE__),'>',$0D,$0A" ;
	       
     nTestEmail = 0 ;
     }

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)

